%   File   : color.pl
%   Author : Neng-Fa ZHOU
%   Date   : 1992
%   Purpose: Backtracking algorithm for coloring Gardner's map
top :- true :
    regions(Rs),
    solve(Rs,[],P),!.

regions(Rs):-
    true :
    Rs:=[1,2,3,4,5,6,7,8,9,10,
                 11,12,13,14,15,16,17,18,19,20,
                 21,22,23,24,25,26,27,28,29,30,
                 31,32,33,34,35,36,37,38,39,40,
                 41,42,43,44,45,46,47,48,49,50,
                 51,52,53,54,55,56,57,58,59,60,
                 61,62,63,64,65,66,67,68,69,70,
                 71,72,73,74,75,76,77,78,79,80,
                 81,82,83,84,85,86,87,88,89,90,
                 91,92,93,94,95,96,97,98,99,100,
                 101,102,103,104,105,106,107,108,109,110].

solve([],P0,Pn):-
    true :
    Pn=P0.
solve([R|Rs],P0,Pn):-
    true :
    color(C),
    consistent(R,C,P0),
    solve(Rs,[region(R,C)|P0],Pn).

consistent(R,C,[]):- true : true.
consistent(R,C,[region(R1,C)|P]):-
    neighbor(R1,R) : 
    fail.
consistent(R,C,[_|P]):-
    true :
    consistent(R,C,P).

color(X):-true ? X:=red.
color(X):-true ? X:=blue.
color(X):-true ? X:=black.
color(X):-true ? X:=yellow.


neighbor(1,2):-true : true.
neighbor(1,3):-true : true.
neighbor(1,4):-true : true.
neighbor(1,5):-true : true.
neighbor(1,6):-true : true.
neighbor(1,7):-true : true.
neighbor(1,8):-true : true.
neighbor(1,9):-true : true.
neighbor(1,10):-true : true.
neighbor(1,11):-true : true.
neighbor(1,20):-true : true.
neighbor(1,73):-true : true.
neighbor(1,109):-true : true.
neighbor(1,110):-true : true.
neighbor(2,3):-true : true.
neighbor(2,12):-true : true.
neighbor(2,57):-true : true.
neighbor(2,102):-true : true.
neighbor(2,103):-true : true.
neighbor(2,104):-true : true.
neighbor(2,105):-true : true.
neighbor(2,106):-true : true.
neighbor(2,110):-true : true.
neighbor(3,4):-true : true.
neighbor(3,12):-true : true.
neighbor(3,13):-true : true.
neighbor(4,5):-true : true.
neighbor(4,13):-true : true.
neighbor(4,14):-true : true.
neighbor(5,6):-true : true.
neighbor(5,14):-true : true.
neighbor(5,15):-true : true.
neighbor(6,7):-true : true.
neighbor(6,15):-true : true.
neighbor(6,16):-true : true.
neighbor(7,8):-true : true.
neighbor(7,16):-true : true.
neighbor(7,17):-true : true.
neighbor(8,9):-true : true.
neighbor(8,17):-true : true.
neighbor(8,18):-true : true.
neighbor(9,10):-true : true.
neighbor(9,18):-true : true.
neighbor(9,19):-true : true.
neighbor(10,11):-true : true.
neighbor(10,19):-true : true.
neighbor(10,20):-true : true.
neighbor(11,20):-true : true.
neighbor(12,13):-true : true.
neighbor(12,21):-true : true.
neighbor(12,57):-true : true.
neighbor(12,58):-true : true.
neighbor(13,14):-true : true.
neighbor(13,21):-true : true.
neighbor(13,22):-true : true.
neighbor(14,15):-true : true.
neighbor(14,22):-true : true.
neighbor(14,23):-true : true.
neighbor(15,16):-true : true.
neighbor(15,23):-true : true.
neighbor(15,24):-true : true.
neighbor(16,17):-true : true.
neighbor(16,24):-true : true.
neighbor(16,25):-true : true.
neighbor(17,18):-true : true.
neighbor(17,25):-true : true.
neighbor(17,26):-true : true.
neighbor(18,19):-true : true.
neighbor(18,26):-true : true.
neighbor(18,27):-true : true.
neighbor(19,20):-true : true.
neighbor(19,27):-true : true.
neighbor(19,28):-true : true.
neighbor(20,28):-true : true.
neighbor(20,73):-true : true.
neighbor(21,22):-true : true.
neighbor(21,29):-true : true.
neighbor(21,58):-true : true.
neighbor(21,59):-true : true.
neighbor(22,23):-true : true.
neighbor(22,29):-true : true.
neighbor(22,30):-true : true.
neighbor(23,24):-true : true.
neighbor(23,30):-true : true.
neighbor(23,31):-true : true.
neighbor(24,25):-true : true.
neighbor(24,31):-true : true.
neighbor(24,32):-true : true.
neighbor(25,26):-true : true.
neighbor(25,32):-true : true.
neighbor(25,33):-true : true.
neighbor(26,27):-true : true.
neighbor(26,33):-true : true.
neighbor(26,34):-true : true.
neighbor(27,28):-true : true.
neighbor(27,34):-true : true.
neighbor(27,35):-true : true.
neighbor(28,35):-true : true.
neighbor(28,72):-true : true.
neighbor(28,73):-true : true.
neighbor(29,30):-true : true.
neighbor(29,36):-true : true.
neighbor(29,59):-true : true.
neighbor(29,60):-true : true.
neighbor(30,31):-true : true.
neighbor(30,36):-true : true.
neighbor(30,37):-true : true.
neighbor(31,32):-true : true.
neighbor(31,37):-true : true.
neighbor(31,38):-true : true.
neighbor(32,33):-true : true.
neighbor(32,38):-true : true.
neighbor(32,39):-true : true.
neighbor(33,34):-true : true.
neighbor(33,39):-true : true.
neighbor(33,40):-true : true.
neighbor(34,35):-true : true.
neighbor(34,40):-true : true.
neighbor(34,41):-true : true.
neighbor(35,41):-true : true.
neighbor(35,71):-true : true.
neighbor(35,72):-true : true.
neighbor(36,37):-true : true.
neighbor(36,42):-true : true.
neighbor(36,60):-true : true.
neighbor(36,61):-true : true.
neighbor(37,38):-true : true.
neighbor(37,42):-true : true.
neighbor(37,43):-true : true.
neighbor(38,39):-true : true.
neighbor(38,43):-true : true.
neighbor(38,44):-true : true.
neighbor(39,40):-true : true.
neighbor(39,44):-true : true.
neighbor(39,45):-true : true.
neighbor(40,41):-true : true.
neighbor(40,45):-true : true.
neighbor(40,46):-true : true.
neighbor(41,46):-true : true.
neighbor(41,70):-true : true.
neighbor(41,71):-true : true.
neighbor(42,43):-true : true.
neighbor(42,47):-true : true.
neighbor(42,61):-true : true.
neighbor(42,62):-true : true.
neighbor(43,44):-true : true.
neighbor(43,47):-true : true.
neighbor(43,48):-true : true.
neighbor(44,45):-true : true.
neighbor(44,48):-true : true.
neighbor(44,49):-true : true.
neighbor(45,46):-true : true.
neighbor(45,49):-true : true.
neighbor(45,50):-true : true.
neighbor(46,50):-true : true.
neighbor(46,69):-true : true.
neighbor(46,70):-true : true.
neighbor(47,48):-true : true.
neighbor(47,51):-true : true.
neighbor(47,62):-true : true.
neighbor(47,63):-true : true.
neighbor(48,49):-true : true.
neighbor(48,51):-true : true.
neighbor(48,52):-true : true.
neighbor(49,50):-true : true.
neighbor(49,52):-true : true.
neighbor(49,53):-true : true.
neighbor(50,53):-true : true.
neighbor(50,68):-true : true.
neighbor(50,69):-true : true.
neighbor(51,52):-true : true.
neighbor(51,54):-true : true.
neighbor(51,63):-true : true.
neighbor(51,64):-true : true.
neighbor(52,53):-true : true.
neighbor(52,54):-true : true.
neighbor(52,55):-true : true.
neighbor(53,55):-true : true.
neighbor(53,67):-true : true.
neighbor(53,68):-true : true.
neighbor(54,55):-true : true.
neighbor(54,56):-true : true.
neighbor(54,64):-true : true.
neighbor(54,65):-true : true.
neighbor(55,56):-true : true.
neighbor(55,66):-true : true.
neighbor(55,67):-true : true.
neighbor(56,65):-true : true.
neighbor(56,66):-true : true.
neighbor(57,58):-true : true.
neighbor(57,102):-true : true.
neighbor(58,59):-true : true.
neighbor(58,95):-true : true.
neighbor(58,102):-true : true.
neighbor(59,60):-true : true.
neighbor(59,89):-true : true.
neighbor(59,95):-true : true.
neighbor(60,61):-true : true.
neighbor(60,84):-true : true.
neighbor(60,89):-true : true.
neighbor(61,62):-true : true.
neighbor(61,80):-true : true.
neighbor(61,84):-true : true.
neighbor(62,63):-true : true.
neighbor(62,77):-true : true.
neighbor(62,80):-true : true.
neighbor(63,64):-true : true.
neighbor(63,75):-true : true.
neighbor(63,77):-true : true.
neighbor(64,65):-true : true.
neighbor(64,74):-true : true.
neighbor(64,75):-true : true.
neighbor(65,66):-true : true.
neighbor(65,74):-true : true.
neighbor(66,67):-true : true.
neighbor(66,74):-true : true.
neighbor(67,68):-true : true.
neighbor(67,74):-true : true.
neighbor(67,76):-true : true.
neighbor(68,69):-true : true.
neighbor(68,76):-true : true.
neighbor(68,79):-true : true.
neighbor(69,70):-true : true.
neighbor(69,79):-true : true.
neighbor(69,83):-true : true.
neighbor(70,71):-true : true.
neighbor(70,83):-true : true.
neighbor(70,88):-true : true.
neighbor(71,72):-true : true.
neighbor(71,88):-true : true.
neighbor(71,94):-true : true.
neighbor(72,73):-true : true.
neighbor(72,94):-true : true.
neighbor(72,101):-true : true.
neighbor(73,101):-true : true.
neighbor(73,109):-true : true.
neighbor(74,75):-true : true.
neighbor(74,76):-true : true.
neighbor(75,76):-true : true.
neighbor(75,77):-true : true.
neighbor(75,78):-true : true.
neighbor(76,78):-true : true.
neighbor(76,79):-true : true.
neighbor(77,78):-true : true.
neighbor(77,80):-true : true.
neighbor(77,81):-true : true.
neighbor(78,79):-true : true.
neighbor(78,81):-true : true.
neighbor(78,82):-true : true.
neighbor(79,82):-true : true.
neighbor(79,83):-true : true.
neighbor(80,81):-true : true.
neighbor(80,84):-true : true.
neighbor(80,85):-true : true.
neighbor(81,82):-true : true.
neighbor(81,85):-true : true.
neighbor(81,86):-true : true.
neighbor(82,83):-true : true.
neighbor(82,86):-true : true.
neighbor(82,87):-true : true.
neighbor(83,87):-true : true.
neighbor(83,88):-true : true.
neighbor(84,85):-true : true.
neighbor(84,89):-true : true.
neighbor(84,90):-true : true.
neighbor(85,86):-true : true.
neighbor(85,90):-true : true.
neighbor(85,91):-true : true.
neighbor(86,87):-true : true.
neighbor(86,91):-true : true.
neighbor(86,92):-true : true.
neighbor(87,88):-true : true.
neighbor(87,92):-true : true.
neighbor(87,93):-true : true.
neighbor(88,93):-true : true.
neighbor(88,94):-true : true.
neighbor(89,90):-true : true.
neighbor(89,95):-true : true.
neighbor(89,96):-true : true.
neighbor(90,91):-true : true.
neighbor(90,96):-true : true.
neighbor(90,97):-true : true.
neighbor(91,92):-true : true.
neighbor(91,97):-true : true.
neighbor(91,98):-true : true.
neighbor(92,93):-true : true.
neighbor(92,98):-true : true.
neighbor(92,99):-true : true.
neighbor(93,94):-true : true.
neighbor(93,99):-true : true.
neighbor(93,100):-true : true.
neighbor(94,100):-true : true.
neighbor(94,101):-true : true.
neighbor(95,96):-true : true.
neighbor(95,102):-true : true.
neighbor(95,103):-true : true.
neighbor(96,97):-true : true.
neighbor(96,103):-true : true.
neighbor(96,104):-true : true.
neighbor(97,98):-true : true.
neighbor(97,104):-true : true.
neighbor(97,105):-true : true.
neighbor(98,99):-true : true.
neighbor(98,105):-true : true.
neighbor(98,106):-true : true.
neighbor(99,100):-true : true.
neighbor(99,106):-true : true.
neighbor(99,107):-true : true.
neighbor(100,101):-true : true.
neighbor(100,107):-true : true.
neighbor(100,108):-true : true.
neighbor(101,108):-true : true.
neighbor(101,109):-true : true.
neighbor(102,103):-true : true.
neighbor(103,104):-true : true.
neighbor(104,105):-true : true.
neighbor(105,106):-true : true.
neighbor(106,107):-true : true.
neighbor(106,110):-true : true.
neighbor(107,108):-true : true.
neighbor(107,110):-true : true.
neighbor(108,109):-true : true.
neighbor(108,110):-true : true.
neighbor(109,110):-true : true.
