/* Sterling and Shapiro's N-queens algorithm */

go:-true :
    cputime(Start),
    allqueens,
    cputime(End),
    T is End-Start,
    write('execution time is '),write(T), write(milliseconds).
    

top:-allqueens.

allqueens:-
    true ?
    queens(8,_),
    fail.
allqueens:-true : true.


queens(N,Qs):-true :
	range(1,N,Ns),
	queens(Ns,[],Qs).

queens([],Qs0,Qsn):-true : Qsn:=Qs0.
queens(UnplacedQs,SafeQs,Qs):-true :
    select(Q,UnplacedQs,UnplacedQs1),
    not_attack(Q,SafeQs),
%    write(rest),write(UnplacedQs1),nl,
    queens(UnplacedQs1,[Q|SafeQs],Qs).

not_attack(Q,SafeQs):-
	attack(Q,SafeQs) :
	fail.
not_attack(_,_):-true : true.


range(M,N,L):-M<N :
    L=[M|Ns],
    M1 is M+1,
    range(M1,N,Ns).
range(M,N,L):-true : L:=[N].


select(X1,[X|Xs],Xs1):-true ? X1:=X,Xs1:=Xs.
select(X,[Y|Ys],L):-true : L:=[Y|Xs],
	select(X,Ys,Xs).

attack(X,Xs):-true :
    attack(X,1,Xs).


attack(X,N,[Y|Ys]):-
	X=:=Y+N : true.
attack(X,N,[Y|Ys]):-
	X=:=Y-N : true.
attack(X,N,[Y|Ys]):-true :
	N1 is N+1,
	attack(X,N1,Ys).


