go:-
    open(res_bp,write,S),
    run(S).

run(S):-
    programs(Ps),
    '$member'((P,N),Ps),
    run_program(P,N,S),
    fail.
run(S):-close(S).

run_program(P,N,S):-
    compile(P),
    load(P),
    ntimes(N,T),!,
    write(S,P),write(S,'('), T1 is T/N, write(S,T1), write(S,').'),nl(S).

ntimes(N,T):-
    statistics(runtime,[Start,_]),
    ntimes(N),
    statistics(runtime,[End,_]),
    T is End-Start.
    
ntimes(N):-N=:=0,!.
ntimes(N):-top, !, N1 is N-1,ntimes(N1).

ratios(F1,F2):-
    readall(F1,L1),
    readall(F2,L2),
    write(ratios),nl,
    compute_ratios(L1,L2,0,0).

readall(F,L):-
    see(F),
    read(X),
    read_data(X,L).

read_data(end_of_file,L):-!,L=[],seen.
read_data(X,L):-
    L=[X|L1],
    read(NewX),
    read_data(NewX,L1).

compute_ratios([],[],Ps,Mean):-write('number of programs:'),write(Ps),nl,
    Temp is Mean/Ps, write('mean ratio:'), write(Temp).
compute_ratios([X|Xs],[Y|Ys],Ps,Mean):-
    functor(X,F,N),
    functor(Y,F,N),
    arg(1,X,Ax),
    arg(1,Y,Ay),
    (Ay=:=0->R=1;R is Ax/Ay),
    write(F),write('('),write(R),write(')'),write('.'),nl,
    Ps1 is Ps+1,
    Mean1 is Mean+R,
    compute_ratios(Xs,Ys,Ps1,Mean1).

top2(P,S):- set_stacks(L1,G1,T1,N1),
    top,
    get_stacks(L2,G2,T2,N2),
    L is L2-L1,
    G is G2-G1,
    T is T2-T1,
    N is N1-N2,
    C is L+N,
    write(S,'control_'),write(S,P),write(S,'('),write(S,C),write(S,').'),nl(S),
    write(S,'global_'),write(S,P),write(S,'('),write(S,G),write(S,').'),nl(S),
    write(S,'trail_'),write(S,P),write(S,'('),write(S,T),write(S,').'),nl(S).

programs(Ps):-
    Ps=[(boyer,2),
	(color,1),
	(fastcolor,2),
	(intersect,2),
	(member,2),
	(nrev,1),
	(queens,10)].

'$member'(X,[X1|Xs]):-
    X=X1.
'$member'(X,[X1|Xs]):-
    '$member'(X,Xs).
