:-prolog_flag(redefine_warnings,X,off).
:-prolog_flag(single_var_warnings,X,off).

go:-
    open(res_sics,write,S),
    run(S).

run(S):-
    programs(Ps),
    '$member'((P,N),Ps),
    run_program(P,N,S),
    fail.
run(S):-close(S).

run_program(P,N,S):-
    compile(P),
    ntimes(N,T),!,
    write(S,P),write(S,'('), T1 is T/N, write(S,T1), write(S,').'),nl(S).

ntimes(N,T):-
    statistics(runtime,[Start,_]),
    ntimes(N),
    statistics(runtime,[End,_]),
    T is End-Start.
    
ntimes(N):-N=:=0,!.
ntimes(N):-top, !, N1 is N-1,ntimes(N1).

ratios(F1,F2):-
    readall(F1,L1),
    readall(F2,L2),
    write(ratios),nl,
    compute_ratios(L1,L2,0,0).

readall(F,L):-
    see(F),
    read(X),
    read_data(X,L).

read_data(end_of_file,L):-!,L=[],seen.
read_data(X,L):-
    L=[X|L1],
    read(NewX),
    read_data(NewX,L1).

compute_ratios([],[],Ps,Mean):-write('number of programs:'),write(Ps),nl,
    Temp is round(Mean/Ps*100)/100, write('mean ratio:'), write(Temp).
compute_ratios([X|Xs],[Y|Ys],Ps,Mean):-
    functor(X,F,N),
    functor(Y,F,N),
    arg(1,X,Ax),
    arg(1,Y,Ay),
    (Ay=:=0->R=1;R is Ax/Ay),
    RoundR is round(R*100)/100,
    write(F),write('('),write(RoundR),write(')'),write('.'),nl,
    Ps1 is Ps+1,
    Mean1 is Mean+RoundR,
    compute_ratios(Xs,Ys,Ps1,Mean1).

programs(Ps):-
    Ps=[(boyer,2),
	(color,1),
	(fastcolor,2),
	(intersect,2),
	(member,2),
	(nrev,1),
	(queens,10)].

'$member'(X,[X1|Xs]):-
    X=X1.
'$member'(X,[X1|Xs]):-
    '$member'(X,Xs).
