/* Find distinct non-zero digits such that the following equation holds:
        A        D        G
     ------  + ----- + ------  = 1
       B*C      E*F      H*I
*/
go:-
	Vars=[A,B,C,D,E,F,G,H,I],
	Vars in 0..9,
	[D1,D2,D3] in 0..81,
	alldifferent(Vars),
	D1 #= B*C,
	D2 #= E*F,
	D3 #= H*I,
	A*D2*D3 + D*D1*D3 + G*D1*D2 #= D1*D2*D3,
	% break the symmetry
	A*D2 #>= D*D1,
	D*D3 #>= G*D2,
	%redundant constraints
	3*A #>= D1,
	3*G #=< D2,
	labeling_ff(Vars),
	write(Vars),nl.

mylabeling([X|Xs]):-!,
	indomain(X),
	write(Xs),nl,
	mylabeling(Xs).
mylabeling(Xs).
	