#include "cpreds.h"

#define MAX_ARITY 255

/************ builtins for creating and accessing arrays ************/
LONG create_array(size)
register int size;
{
  register LONG_PTR temp_hreg,return_hreg;
  register int i,arity;
  SYM_REC_PTR sym_ptr,insert();
  
  if (size>=MAX_ARITY)
    arity = MAX_ARITY;
  else
    arity = size;
  sym_ptr = insert("array",5,arity);
  return_hreg = temp_hreg = hreg;
  *temp_hreg++ = (LONG)sym_ptr;
  for (i=0;i<arity;i++){
    *temp_hreg++ = (LONG)NULL;
  }
  hreg = temp_hreg;
  LOCAL_OVERFLOW;
  if (size!=arity)
    FOLLOW(return_hreg+MAX_ARITY) = create_array(size-MAX_ARITY+1);
  return ADDTAG(return_hreg,STR);
} 

LONG get_array(i,array)
register i;
register LONG_PTR array;
{
  register LONG_PTR ptr;
  register LONG return_val;
  
  while (i>=MAX_ARITY){
    i = i-MAX_ARITY+1;
    array = (LONG_PTR)UNTAGGED(FOLLOW(array+MAX_ARITY));
  }
  ptr = array+i;
  return_val = FOLLOW(ptr);
  if (return_val == (LONG)NULL){
    return_val = (LONG)hreg;
    PUSHTRAILB(ptr,(LONG)NULL);
    FOLLOW(ptr) = return_val;
    NEW_HEAP_FREE;
    return return_val;
  }
  else return return_val;
}
 
c_CREATE_ARRAY(){
  LONG Size,Array;
  
  Size = ARG(1,2);
  Array = ARG(2,2);
  
  DEREF(Size);
  if (!ISINT(Size)){
    exception = integer_expected;
    return -1;
  }
  Size = INTVAL(Size);
  if (Size<=0)
    return unify(Array,nil_sym);
  else
    return unify(Array,create_array(Size));
}

c_GET_ARRAY(){
  LONG I,Array,Elm;
  
  I = ARG(1,3);
  Array = ARG(2,3);
  Elm = ARG(3,3);
  
  DEREF(I);
  if (!ISINT(I)){
    exception = integer_expected;
    return -1;
  }
  DEREF(Array);
  if (!ISSTRUCT(Array)){
    exception = illegal_arguments;
    return -1;
  }
  return unify(Elm,get_array(INTVAL(I),UNTAGGED(Array)));
}

