/*
*   File   : assert.c
*   Author : Neng-Fa ZHOU
*   Date   : Completed December 1995
*   Purpose: assert global database
*   Copyright (C) All rights reserved
*/
#include "cpreds.h"
#include "dynamic.h"



b_ASSERT_TMP_cf(Clause,No)
register TERM Clause,No;
{
  TERM Head,assert_clause;
  register SYM_REC_PTR sym_ptr;

  PAREA_TOP(1);
  c_assert_tmp1(Clause,No,&assert_clause,&Head); /* dynamic */

  if (ISSTRUCT(Head))
    sym_ptr = (SYM_REC_PTR)FOLLOW(UNTAGGED(Head));
  else
    sym_ptr = (SYM_REC_PTR)UNTAGGED(Head);

  assert_tail(sym_ptr,make_cons(assert_clause,nil_sym));
  UPDATE_CURR_FENCE(1);
  return 1;
}

b_ASSERTA_TMP_cf(Clause,No)
register TERM Clause,No;
{
  TERM Head,assert_clause;
  register SYM_REC_PTR sym_ptr;
  
  PAREA_TOP(1);
  c_assert_tmp1(Clause,No,&assert_clause,&Head);
  if (ISSTRUCT(Head))
    sym_ptr = (SYM_REC_PTR)FOLLOW(UNTAGGED(Head));
  else
    sym_ptr = (SYM_REC_PTR)UNTAGGED(Head);

  GET_EP(sym_ptr) = (int (*)())make_cons(assert_clause,GET_EP(sym_ptr));
  UPDATE_CURR_FENCE(1);
  return 1;
}

b_ASSERT_STATIC_TMP_c(Clause)
register TERM Clause;
{
  TERM Head,assert_clause;
  register SYM_REC_PTR sym_ptr;
  
  PAREA_TOP(1);
  c_assert_static_tmp1(Clause,&assert_clause,&Head);
  if (ISSTRUCT(Head))
    sym_ptr = (SYM_REC_PTR)FOLLOW(UNTAGGED(Head));
  else
    sym_ptr = (SYM_REC_PTR)UNTAGGED(Head);

  GET_EP(sym_ptr) = (int (*)())make_cons(assert_clause,GET_EP(sym_ptr));
  UPDATE_CURR_FENCE(1);
  return 1;
}

b_ASSERTA_HASHTAB_cc(Size,Clause)
register TERM Size,Clause;
{
  register LONG_PTR top;
  register int index;
  TERM Head,assert_clause,Arg1,HValue,temp;
  register SYM_REC_PTR sym_ptr;

  PAREA_TOP(1);
  DEREF(Size); Size = INTVAL(Size);
  c_assert_static_tmp1(Clause,&assert_clause,&Head);
  sym_ptr = (SYM_REC_PTR)FOLLOW(UNTAGGED(Head));
  Arg1 = FOLLOW((LONG_PTR)UNTAGGED(Head)+1); /* arg(1,Head,Arg1) */
  
  if (IsNumberedVar(Arg1)){
    temp = assert_hashtab_all((LONG)GET_EP(sym_ptr),Size,assert_clause);
  } else {
    b_HASHVAL1_cf(Arg1,&HValue);
    index = INTVAL(HValue) % (Size-1) + 1;
    temp =  assert_hashtab_one((LONG)GET_EP(sym_ptr),Size,index,assert_clause);
  }
  UPDATE_CURR_FENCE(1);
  return temp;
}

assert_hashtab_one(hashtab,size,index,clause)
register int size,index;
register LONG hashtab,clause;
{
  register LONG_PTR top;
  register LONG temp;
  
  DEREF(clause);
  DEREF(hashtab);

  UNTAG(hashtab);
  if (size==index){
    temp =  *((LONG_PTR)hashtab+index);
    *((LONG_PTR)hashtab+index) = make_cons(clause,temp,1);
  }
  else {
    temp =  *((LONG_PTR)hashtab+size);
    *((LONG_PTR)hashtab+size) = make_cons(clause,temp,1);
    temp =  *((LONG_PTR)hashtab+index);
    *((LONG_PTR)hashtab+index) = make_cons(clause,temp,1);
  }
  return 1;
}

assert_hashtab_all(hashtab,size,clause)
register int size;
register LONG hashtab,clause;
{
  register LONG_PTR top;
  LONG temp,index;
  
  DEREF(hashtab);
  UNTAG(hashtab);
  for (index=1;index<=size;index++){
    temp =  *((LONG_PTR)hashtab+index);
    *((LONG_PTR)hashtab+index) = make_cons(clause,temp,1);
  }
  return 1;
}

c_assert_tmp1(Clause,No,assert_clause,Head)
TERM Clause,No;
TERM *Head,*assert_clause;
{
  TERM ClauseCp,Body,temp,new_global_clause_no();
  register LONG_PTR ptr;
  
  ClauseCp = heap_to_parea_reuse(Clause,nil_sym);
  c_head_body(ClauseCp,Head,&Body);
  temp = new_global_clause_no();
  ALLOCATE_FROM_PAREA(5,ptr);
  *assert_clause = ADDTAG(ptr,STR);
  FOLLOW(ptr++) = (LONG)clause4_sym;
  FOLLOW(ptr++) = temp;
  FOLLOW(ptr++) = MAKEINT(1);
  FOLLOW(ptr++) = FOLLOW(Head);
  FOLLOW(ptr) = Body;
  FOLLOW(No) = temp;

  return 1;
}

c_assert_static_tmp1(Clause,assert_clause,Head)
TERM Clause;
TERM *Head,*assert_clause;
{
  TERM ClauseCp,Body;
  register LONG_PTR ptr;

  ClauseCp = heap_to_parea_reuse(Clause,nil_sym);
  c_head_body(ClauseCp,Head,&Body);
  ALLOCATE_FROM_PAREA(3,ptr);
  *assert_clause = ADDTAG(ptr,STR);
  FOLLOW(ptr++) = (LONG)clause2_sym;
  FOLLOW(ptr++) = FOLLOW(Head);
  FOLLOW(ptr) = Body;

  return 1;
}

c_head_body(Clause,Head,Body)
register TERM Clause;
register TERM *Head,*Body;
{
  register LONG_PTR top;
  TERM F,H,G,cut,tmp,B,B1,N,body;
  char *name;
  
  DEREF(Clause);
  if (ISSTRUCT(Clause) && (SYM_REC_PTR)FOLLOW(UNTAGGED(Clause))==imply_sym){
    H = FOLLOW((LONG_PTR)UNTAGGED(Clause)+1);
    B1 = FOLLOW((LONG_PTR)UNTAGGED(Clause)+2);
    FOLLOW(Head) = H;
    FOLLOW(Body) = B1;
  } else {
    FOLLOW(Head) = Clause;
    FOLLOW(Body) = build_ATOM("true");
  }
  return 1;
}
      
b_GLOBAL_CLAUSE_NO_f(No)
register TERM No;
{
  register LONG_PTR top;
  
  ASSIGN_f(No,(LONG)GET_EP(clause_no_sym));
  return 1;
}

TERM new_global_clause_no()
{
  int cno;
  TERM pno;

  pno = (LONG)GET_EP(clause_no_sym);
  cno  = INTVAL(pno)+1;
  pno = MAKEINT(cno);
  GET_EP(clause_no_sym) = (int (*)())pno;
  return pno;
}
       
b_ASSERTABLE_c(Head)
register TERM Head;
{
  register SYM_REC_PTR sym_ptr;
  register LONG_PTR top;
  
  DEREF(Head);
  if (ISSTRUCT(Head)) 
    sym_ptr = (SYM_REC_PTR)FOLLOW(UNTAGGED(Head));
  else if (ISATOM(Head)) 
    sym_ptr = (SYM_REC_PTR)UNTAGGED(Head);
  else return 0;
  if (GET_ETYPE(sym_ptr)==T_ORDI){
    GET_EP(sym_ptr) = (int (*)())nil_sym;
    GET_ETYPE(sym_ptr) = T_DYNA;
    return 1;
  }
  else if (GET_ETYPE(sym_ptr) == T_DYNA) 
    return state_is_dynamic(sym_ptr);
  else   return 0;
}

b_RETRACTABLE_c(Head)
register TERM Head;
{
  register SYM_REC_PTR sym_ptr;
  register LONG_PTR top;

  DEREF(Head);
  if (ISSTRUCT(Head)) 
    sym_ptr = (SYM_REC_PTR)FOLLOW(UNTAGGED(Head));
  else if (ISATOM(Head)) 
    sym_ptr = (SYM_REC_PTR)UNTAGGED(Head);
  else return 0;
  if (GET_ETYPE(sym_ptr) == T_DYNA) 
    return state_is_dynamic(sym_ptr);
  return 0;
}
  
state_is_dynamic(sym_ptr)
SYM_REC_PTR sym_ptr;
{
  TERM Clauses,Clause,State;
  
  Clauses = (TERM)GET_EP(sym_ptr);
  if (ISLIST(Clauses)){
    DEREF(Clauses);
    Clause = FETCH_CAR(Clauses);
    DEREF(Clause);
    if (ISSTRUCT(Clause) && (SYM_REC_PTR)FOLLOW(UNTAGGED(Clause)) == clause4_sym)
      return 1;
    else 
      return 0;
  }
  return (ISNIL(Clauses)) ? 1 : 0;
}
  
b_GET_CLAUSES_cf(Head,Clauses)
  register TERM Head,Clauses;
{
  register SYM_REC_PTR sym_ptr;
  register LONG_PTR top;

  DEREF(Head);
  if (ISSTRUCT(Head)) 
    sym_ptr = (SYM_REC_PTR)FOLLOW(UNTAGGED(Head));
  else if (ISATOM(Head)) 
    sym_ptr = (SYM_REC_PTR)UNTAGGED(Head);
  else return 0;
  if (GET_ETYPE(sym_ptr)!=T_DYNA) {
    return 0;
  }
  ASSIGN_f(Clauses,(LONG)GET_EP(sym_ptr));
  return 1;
}

Cboot_assert(){
  SYM_REC_PTR insert_cfunc();

  colon_sym = insert_cfunc(":",2);
  question_sym = insert_cfunc("?",2);
  imply_sym = insert_cfunc(":-",2);
  clause2_sym = insert_cfunc("clause",2);
  clause4_sym = insert_cfunc("clause",4);
  clause_no_sym = insert_cfunc("$clause_no",0);
}

