/*
*   File   : clause.c
*   Author : Neng-Fa ZHOU
*   Date   : Completed December 1995
*   Purpose: auxiliary functions for defining clause/2
*   Copyright (C) All rights reserved
*/
#include "cpreds.h"
#include "dynamic.h"

/*********************************************************************
clause1(Head,Arity,Body,No,CurrNo,clause(Head1,Body1)):-
    true :
    clause_unify_head_args(1,Arity,Head1,Head,Table),
    b_COPY_UNNUMBER_VARS(Body1,Body2,Table),
    Body=Body2.
clause1(Head,Arity,Body,No,CurrNo,clause(ClNo,State,Head1,Body1)):-
    State>0,
    ClNo=<CurrNo :
    clause_unify_head_args(1,Arity,Head1,Head,Table),
    b_COPY_UNNUMBER_VARS(Body1,Body2,Table),
    Body=Body2,
    No=ClNo.
*********************************************************************/
c_clause(){
  LONG_PTR top,ptr;
  TERM Head,Arity,Body,No,CurrNo,Clause,Head1,Body1,ClNo,State,goalA,headA;
  LONG_PTR goal_ptr,head_ptr,varVector = arreg-7;
  int i,maxVarNo=0;
  
  
  Head = ARG(1,6);DEREF(Head);
  Arity = ARG(2,6);DEREF(Arity); Arity = INTVAL(Arity);
  Body = ARG(3,6);
  Clause = ARG(6,6);DEREF(Clause);
  
  if (ISSTRUCT(Clause)){
    ptr = (LONG_PTR)UNTAGGED(Clause);
    if (FOLLOW(ptr) == (LONG)clause2_sym) {
      Head1 = FOLLOW(ptr+1);
      Body1 = FOLLOW(ptr+2);  
    } else if (FOLLOW(ptr) == (LONG)clause4_sym) {
      State = FOLLOW(ptr+2); 
      if (INTVAL(State) <= 0) return 0;
      CurrNo = ARG(5,6);ClNo = FOLLOW(ptr+1); 
      DEREF(CurrNo);
      if (INTVAL(ClNo)>INTVAL(CurrNo)) return 0;
      Head1 = FOLLOW(ptr+3);
      Body1 = FOLLOW(ptr+4);
      No = ARG(4,6);
      unify(No,ClNo);
    } else return 0;
    head_ptr = (LONG_PTR)UNTAGGED(Head1);
    goal_ptr = (LONG_PTR)UNTAGGED(Head);
    for (i=1; i<=Arity; i++){
      headA = FOLLOW(head_ptr+i);
      goalA = FOLLOW(goal_ptr+i);
      if (!clause_unify_head_arg(headA,goalA,varVector,&maxVarNo)) return 0;
    }
    Body1 = unnumberVarTerm(Body1,varVector,&maxVarNo);
    return unify(Body,Body1);      
  }
  return 0;
}

clause_unify_head_arg(headA,goalA,varVector,maxVarNo)
LONG  headA,goalA;
LONG_PTR varVector;
int *maxVarNo;
{
  LONG_PTR top,goal_ptr,head_ptr;
  int varNo;

  DEREF(goalA);
  if (ISVAR(goalA) || IS_SUSP_VAR(goalA))
    return unify(goalA,unnumberVarTerm(headA,varVector,maxVarNo));

  if (TAG(headA)==ATM) return headA==goalA;
  else if (IsNumberedVar(headA)){
    varNo = INTVAL(headA);
    if (varNo>FOLLOW(maxVarNo)){
      FOLLOW(maxVarNo) = varNo;
      headA = (LONG)hreg;
      NEW_HEAP_FREE;
      FOLLOW(varVector-varNo) = headA;
    } else {
      headA = FOLLOW(varVector-varNo);
    }      
    return unify(headA,goalA);
  } else if (ISLIST(headA)){
    if (ISLIST(goalA)){
      head_ptr = (LONG_PTR)UNTAGGED(headA);
      goal_ptr = (LONG_PTR)UNTAGGED(goalA);
      return (clause_unify_head_arg(FOLLOW(head_ptr),FOLLOW(goal_ptr),varVector,maxVarNo) &&
	      clause_unify_head_arg(FOLLOW(head_ptr+1),FOLLOW(goal_ptr+1),varVector,maxVarNo));
    } else return 0;
  } else { /* headA is STR */
    if (ISSTRUCT(goalA)){
      int i,arity;
      head_ptr = (LONG_PTR)UNTAGGED(headA);
      goal_ptr = (LONG_PTR)UNTAGGED(goalA);
      if (FOLLOW(head_ptr)!=FOLLOW(goal_ptr)) return 0;
      arity = GET_ARITY((SYM_REC_PTR)FOLLOW(head_ptr));
      for (i = 1; i <= arity; i++){
	if (!clause_unify_head_arg(FOLLOW(head_ptr+i),FOLLOW(goal_ptr+i),varVector,maxVarNo)) return 0;
      }
      return 1;
    } else return 0;
  }
}





      
    
  
    
    
    




      




