#include "cpreds.h"
#include "event.h"
  
extern FILE *curr_out;
/*    print_linear_constr(n,upper); \ */

#define RETURN_0 { \
    return 0; \
}    

#define CALL_DOMAIN_REGION(dv_ptr,min,max){ \
    if (min>max) RETURN_0; \
    if (min > dv_ptr_first) { \
         if (max < dv_ptr_last) { \
           CALL_DOMAIN_REGION_MIN_MAX(dv_ptr,min,max);} \
         else { \
	   CALL_DOMAIN_REGION_MIN(dv_ptr,min);} \
    } else { \
         if (max < dv_ptr_last) { \
           CALL_DOMAIN_REGION_MAX(dv_ptr,max);} \
         } \
 }

#define CALL_DOMAIN_REGION_MIN_MAX(dv_ptr,min,max){ \
  if (min==max){ \
     if (IS_BV_DOMAIN(dv_ptr) && !domain_true_bv(dv_ptr,min)) RETURN_0; \
     ASSIGN_DVAR(dv_ptr,MAKEINT(min)); \
  } else if (IS_IT_DOMAIN(dv_ptr)){ \
     UPDATE_FIRST(dv_ptr,min); \
     UPDATE_LAST(dv_ptr,max); \
     size = max-min+1; \
     UPDATE_SIZE(dv_ptr,size); \
  } else { \
     if (update_domain_region_min_max(dv_ptr,min,max) == 0) RETURN_0;} \
  }

#define CALL_DOMAIN_REGION_MIN(dv_ptr,min){ \
  if (min >= dv_ptr_last) { \
     if (min>dv_ptr_last) RETURN_0; \
     if (IS_BV_DOMAIN(dv_ptr) && !domain_true_bv(dv_ptr,min)) RETURN_0; \
     ASSIGN_DVAR(dv_ptr,MAKEINT(min)); \
  } else  if (IS_IT_DOMAIN(dv_ptr)){ \
     UPDATE_FIRST(dv_ptr,min); \
     size = dv_ptr_last-min+1; \
     UPDATE_SIZE(dv_ptr,size); \
  } else { \
     if (update_domain_region_min(dv_ptr,min)==0) RETURN_0;} \
  }

#define CALL_DOMAIN_REGION_MAX(dv_ptr,max){ \
  if (max <= dv_ptr_first){ \
     if (max < dv_ptr_first) RETURN_0; \
     if (IS_BV_DOMAIN(dv_ptr) && !domain_true_bv(dv_ptr,max)) RETURN_0; \
     ASSIGN_DVAR(dv_ptr,MAKEINT(max)); \
  } else  if (IS_IT_DOMAIN(dv_ptr)){ \
    UPDATE_LAST(dv_ptr,max); \
    size = max-dv_ptr_first+1; \
    UPDATE_SIZE(dv_ptr,size); \
  } else {\
    if (update_domain_region_max(dv_ptr,max)==0) RETURN_0; }\
  }


/* t2 = t1+a*x */
#define COMPUTE_LOW_UPPER_BOUNDS(a,x,l1,u1,l2,u2){ \
   if (IS_SUSP_VAR(x)){ \
      dv_ptr = (LONG_PTR)UNTAGGED(x); \
      first = DV_first(dv_ptr); \
      last = DV_last(dv_ptr); \
      if (a >= 0 ){ \
         l2 = l1+a*first; \
         u2 = u1+a*last; \
      } else { \
         l2 = l1+a*last; \
         u2 = u1+a*first; \
      } \
   } else { \
      x = a*INTVAL(x); \
      l2 = l1+x; \
      u2 = u1+x; \
   } \
}

/* min(t2)-max(a*x)<= t1 <= max(t2)-min(a*x) */
/* min(t2)-max(t1)<= a*x <= max(t2)-min(t1) */
#define REDUCE_DOMAIN(a,x,l1,u1,l2,u2){ \
   if (IS_SUSP_VAR(x)){ \
      dv_ptr = (LONG_PTR)UNTAGGED(x); \
      dv_ptr_first = DV_first(dv_ptr); \
      dv_ptr_last = DV_last(dv_ptr); \
      if (a >= 0 ){ \
         first = l2-a*dv_ptr_last; \
         last = u2-a*dv_ptr_first; \
      } else { \
         first = l2-a*dv_ptr_first; \
         last = u2-a*dv_ptr_last; \
      } \
      if (first>l1) l1=first; \
      if (last<u1) u1=last; \
      if (u1<l1) RETURN_0; \
      if (l1==u1 && l2==u2){ \
         last = (l2-l1); \
         first = last/a; \
         if (a*first!= last) RETURN_0; \
         ASSIGN_DVAR(dv_ptr,MAKEINT(first)); \
      } else { \
         first = l2-u1; \
         last = u2-l1; \
         if (a>0){ \
            if (a==1) { \
              CALL_DOMAIN_REGION(dv_ptr,first,last); \
            } else { \
              UP_DIV(first0,first,a); \
              LOW_DIV(last0,last,a); \
              CALL_DOMAIN_REGION(dv_ptr,first0,last0); \
            } \
         } else if (a<0) { \
           if (a == -1){ \
              first0 = -last; \
              last0 = -first; \
              CALL_DOMAIN_REGION(dv_ptr,first0,last0); \
           } else { \
              UP_DIV(first0,last,a); \
              LOW_DIV(last0,first,a); \
              CALL_DOMAIN_REGION(dv_ptr,first0,last0); \
           } \
        } \
      } \
    } else { \
      x = a*INTVAL(x); \
      if (l2==u2) { \
          if (l1==u1){ \
             if (x+l1!=l2) RETURN_0; \
          } else { \
             first = l2-x; \
             if (first<l1 || first>u1) RETURN_0; \
             l1 = u1 = first; \
         } \
      } else { \
          first = l2-x; \
          last = u2-x; \
          if (first>l1) l1=first; \
          if (last<u1) u1=last; \
          if (u1<l1) RETURN_0; \
          first = l2-u1; \
          last = u2-l1; \
          if (x<first || x> last) RETURN_0; \
     } \
   } \
}

#define UP_DIV(V,X,Y){ \
    if ((X>=0 && Y>=0) || (X<=0 && Y<=0)) { \
        V = X/Y; \
        if (V*Y != X) V++; \
    } else { \
        V = X/Y; \
    } \
}

#define LOW_DIV(V,X,Y){ \
    if ((X>=0 && Y>=0) || (X<=0 && Y<=0)) { \
      V = X/Y; \
    } else { \
      V = X/Y; \
      if (V*Y!=X) V--; \
    } \
}

/* c+a1*x1+...+an*xn = 0 */
int 
  nary_interval_consistent(n,upper)
int n,upper;
{
  int c,i0,i,first,last,first0,last0,dv_ptr_first,dv_ptr_last,size;
  int tl[11],tu[11]; /* assume no constraint contain more than 10 variables */
  LONG a,x;
  register LONG_PTR dv_ptr,var_ptr,coe_ptr;
/*  
  printf("==>nary_interval_consisitent\n"); 
  print_linear_constr(n,upper); 
  printf("********************************************\n");
*/
  var_ptr = arreg+n+1;
  coe_ptr = var_ptr+n;
  c = INTVAL(FOLLOW(coe_ptr)); /* c+a1*x1+...+ak*xk where x1,...,xk are integers */
  i0 = 1;
  do {
    x = FOLLOW(var_ptr-i0);DEREF_NONVAR(x);
    if (ISINT(x)) {
      a = FOLLOW(coe_ptr-i0); 
      c += INTVAL(a)*INTVAL(x);
      i0++;
    } else break;
  } while (i0<=n);
  
/*  if (n<=2){printf("after const i0=%d c=%d\n",i0,c);} */
  /* compute low and upper bounds */
  tl[i0-1] = tu[i0-1] = c;
  for (i=i0;i<=n;i++){ /* compute low and upper bounds */
    a = FOLLOW(coe_ptr-i);a = INTVAL(a);
    x = FOLLOW(var_ptr-i);DEREF_NONVAR(x);
    COMPUTE_LOW_UPPER_BOUNDS(a,x,tl[i-1],tu[i-1],tl[i],tu[i]);
  }

/*  if (n<=2){printf("min=%d max=%d\n",tl[n],tu[n]);} */
  if (tl[n]<0) tl[n]=0; /* tn = tn-1*an*xn = 0 */
  if (tu[n]>upper) tu[n] = upper;
  if (tl[n]>tu[n]) RETURN_0;

  for (i=n;i>=i0;i--){ /* reduce domains */
    a = FOLLOW(coe_ptr-i); a = INTVAL(a);
    x = FOLLOW(var_ptr-i);DEREF_NONVAR(x);
    REDUCE_DOMAIN(a,x,tl[i-1],tu[i-1],tl[i],tu[i]);
  }
/*
  printf("<==nary_interval_consisitent\n"); 
  print_linear_constr(n,upper); 
  printf("===========================================\n\n");
*/  
  return 1;
}

/* c+x1+...+xn = 0 */
int 
  nary_interval_consistent_nocoe(n,upper)
int n,upper;
{
  int c,i0,i,first,last,first0,last0,dv_ptr_first,dv_ptr_last,size;
  int tl[11],tu[11]; /* assume no constraint contain more than 10 variables */
  LONG a,x;
  register LONG_PTR dv_ptr,var_ptr;

  /*
  printf("==>nary_interval_consisitent %d %d\n",n,upper); 
  print_linear_constr(n,upper); 
  printf("********************************************\n");
  */
  var_ptr = arreg+n+1;
  c = INTVAL(FOLLOW(var_ptr+n)); /* c+x1+...+xk where x1,...,xk are integers */
  i0 = 1;
  do {
    x = FOLLOW(var_ptr-i0);DEREF_NONVAR(x);
    if (ISINT(x)) {
      c += INTVAL(x);
      i0++;
    } else break;
  } while (i0<=n);
  
/*  if (n<=2){printf("after const i0=%d c=%d\n",i0,c);} */
  /* compute low and upper bounds */
  tl[i0-1] = tu[i0-1] = c;
  for (i=i0;i<=n;i++){ /* compute low and upper bounds */
    x = FOLLOW(var_ptr-i);DEREF_NONVAR(x);
    COMPUTE_LOW_UPPER_BOUNDS(1,x,tl[i-1],tu[i-1],tl[i],tu[i]);
  }

/*  if (n<=2){printf("min=%d max=%d\n",tl[n],tu[n]);} */
  if (tl[n]<0) tl[n]=0; /* tn = tn-1+xn = 0 */
  if (tu[n]>upper) tu[n] = upper;
  if (tl[n]>tu[n]) RETURN_0;

  for (i=n;i>=i0;i--){ /* reduce domains */
    x = FOLLOW(var_ptr-i);DEREF_NONVAR(x);
    REDUCE_DOMAIN(1,x,tl[i-1],tu[i-1],tl[i],tu[i]);
  }
  /*
  printf("<==nary_interval_consisitent\n"); 
  print_linear_constr(n,upper); 
  printf("===========================================\n\n");
  */
  return 1;
}


print_linear_constr(n,upper)
int n,upper;
{
  int i;
  int c = FOLLOW(arreg+2*n+1);
  curr_out = stdout;
  write_term(c);printf("+");
  for (i=n;i>0;i--){
    write_term(FOLLOW(arreg+n+i));printf("*");
    write_term(FOLLOW(arreg+i));printf("+");
  }
  printf("=%d \n",upper);
}

inst_nary_to_binary(n,c,a1,x1,a2,x2)
TERM n,c,a1,x1,a2,x2;
{
  int i,newC,count=0;
  TERM a,x;

/*  printf("nary to binary %x\n",n); */
  DEREF_NONVAR(n); n=INTVAL(n);
  newC = FOLLOW(arreg+2*n+1); DEREF_NONVAR(newC); newC=INTVAL(newC);
  for (i=1;i<=n;i++){
    a = FOLLOW(arreg+n+i); DEREF_NONVAR(a); 
    x = FOLLOW(arreg+i); DEREF_NONVAR(x); 
    if (IS_SUSP_VAR(x)){
      if (count==0){
	ASSIGN_f(a1,a);
	ASSIGN_f(x1,UNTAGGED(x));
	count++;
      } else {
	ASSIGN_f(a2,a);
	ASSIGN_f(x2,UNTAGGED(x));
	count++;
      }
    } else {
      newC += INTVAL(a)*INTVAL(x);
    }
  }
  ASSIGN_f(c,MAKEINT(newC));
  if (count!=2){
    TERM zero = MAKEINT(0);
    ASSIGN_f(a2,zero);
    ASSIGN_f(x2,zero);
    if (count==0){
      ASSIGN_f(a1,zero);
      ASSIGN_f(x1,zero);
    }
  } 
/*  printf("<=nary to binary\n"); */
  return 1;
}

int 
update_domain_region_min(dv_ptr,min)
register LONG_PTR dv_ptr;
register long int min;
{
  register LONG size;
  register LONG_PTR top;
/*  printf("update_domain_region_min(%x,%d)\n",dv_ptr,min); */
  size = count_domain_elms(dv_ptr,DV_first(dv_ptr),min-1); 
  size = DV_size(dv_ptr)-size;
  if (size == 1){
    ASSIGN_DVAR(dv_ptr,MAKEINT(DV_last(dv_ptr)));
    return 1;
  }
  min = domain_next_bv(dv_ptr,min);
  UPDATE_FIRST(dv_ptr,min);       
  UPDATE_SIZE(dv_ptr,size);
  return 1;
}

int 
update_domain_region_max(dv_ptr,max)
register LONG_PTR dv_ptr;
register LONG max;
{
  register LONG size;
  register LONG first;
  register LONG_PTR top;

/*  printf("update_domain_region_max(%x,%d)\n",dv_ptr,max); */
  size = count_domain_elms(dv_ptr,max+1,DV_last(dv_ptr)); 
  size = DV_size(dv_ptr)-size;
  if (size == 1){
    ASSIGN_DVAR(dv_ptr,MAKEINT(DV_first(dv_ptr)));
    return 1;
  }
  max = domain_prev_bv(dv_ptr,max);
  UPDATE_LAST(dv_ptr,max);       
  UPDATE_SIZE(dv_ptr,size);
  return 1;
}

int 
update_domain_region_min_max(dv_ptr,min,max)
register LONG_PTR dv_ptr;
register long int min,max;
{
  register LONG size;
  register LONG first,last;
  register LONG_PTR top;

/*  printf("update_domain_region_min_max(%x,%d,%d)\n",dv_ptr,min,max); */
  size = count_domain_elms(dv_ptr,DV_first(dv_ptr),min-1); 
  size += count_domain_elms(dv_ptr,max+1,DV_last(dv_ptr)); 
  size = DV_size(dv_ptr)-size;
  if (size == 0) return 0;
  min = domain_next_bv(dv_ptr,min);
  if (size == 1){
    if (IS_BV_DOMAIN(dv_ptr) && !domain_true_bv(dv_ptr,min)) return 0; 
    ASSIGN_DVAR(dv_ptr,MAKEINT(min));
    return 1;
  }
  max = domain_prev_bv(dv_ptr,max);
  UPDATE_FIRST(dv_ptr,min);       
  UPDATE_LAST(dv_ptr,max);       
  UPDATE_SIZE(dv_ptr,size);
  return 1;
}


