#include "cpreds.h"
#include <time.h>

  extern SYM_REC_PTR insert();
extern (*builtins[])();

int identical_VAR_VAR(t1,t2)
TERM t1;
TERM t2;
{
  DEREF(t1);
  DEREF(t2);
  return t1==t2;
}

int is_VAR(t) 
TERM t;
{
  DEREF(t);
  return ISVAR(t);
}

int is_ATOM(t) 
TERM t;
{
  DEREF(t);
  return ISATOM(t);
}

int is_INTEGER(t)
TERM t;
{
  DEREF(t);
  return ISINT(t);
}

int is_FLOAT(t)
TERM t;
{
  DEREF(t);
  return ISFLOAT(t);
}

int is_NIL(t)
TERM t;
{
  DEREF(t);
  return ISNIL(t);
}

int is_LIST(t)
TERM t;
{
  DEREF(t);
  return ISLIST(t);
}

int is_STRUCTURE(t)
TERM t;
{
  DEREF(t);
  return ISSTRUCT(t);
}

int is_COMPOUND(t)
TERM t;
{
  DEREF(t);
  return (ISLIST(t) || ISSTRUCT(t));
}

int get_INTEGER(t) 
TERM t;
{
  DEREF(t);
  return INTVAL(t);
}

double get_FLOAT(t)
TERM t;
{
  double floatval();
  
  DEREF(t);
  return floatval(t);
}

char *get_NAME(t)
TERM t;
{
  DEREF(t);
  return GET_NAME(GET_SYM_REC(t));
}

int get_ARITY(t)
TERM t;
{
  DEREF(t);
  return GET_ARITY(GET_SYM_REC(t));
}

TERM get_ARG(i,t)
int i;
TERM t;
{
  DEREF(t);
  return (ISLIST(t) ?  *((LONG_PTR)UNTAGGED(t)+i-1) : *((LONG_PTR)UNTAGGED(t)+i));
}

TERM make_VAR(){
  NEW_HEAP_FREE;
  return (TERM)(hreg-1);
}

TERM build_VAR(){
  NEW_HEAP_FREE;
  return (TERM)(hreg-1);
}

TERM make_INTEGER(i)
int i;
{
  return MAKEINT(i);
}

TERM build_INTEGER(i)
int i;
{
  return MAKEINT(i);
}

TERM make_FLOAT(f)
double f;
{
  return encodefloat(f);
}

TERM build_FLOAT(f)
double f;
{
  return encodefloat(f);
}
  
TERM make_ATOM(name) 
char *name;
{
  
  return ADDTAG(insert(name,strlen(name),0),ATM);
}

TERM build_ATOM(name) 
char *name;
{
  
  return ADDTAG(insert(name,strlen(name),0),ATM);
}

TERM make_LIST()
{
  return ADDTAG(hreg,LST);
}

TERM build_LIST()
{
  return ADDTAG(hreg,LST);
}

TERM make_NIL()
{
  return nil_sym;
}

TERM build_NIL()
{
  return nil_sym;
}

TERM make_STRUCTURE(name,arity)
char *name;
int arity;
{
  *hreg= (LONG)insert(name,strlen(name),arity);
  return ADDTAG(hreg++,STR);
}

TERM build_STRUCTURE(name,arity)
char *name;
int arity;
{
  *hreg= (LONG)insert(name,strlen(name),arity);
  return ADDTAG(hreg++,STR);
}

void build_ARG(t) 
TERM t;
{
  DEREF(t);
  if (ISVAR(t)){
    *(LONG_PTR)t = (LONG)hreg;
    PUSHTRAIL(t);
    NEW_HEAP_FREE; 
  }              
  else 
    *hreg++ = (TERM)t;
}

currentTime(){
  long t;
  struct tm *ct,*localtime();
  TERM Year,Month,Day,Hour,Min,Sec;

  Year   = ARG(1,6); 
  Month  = ARG(2,6); 
  Day    = ARG(3,6);
  Hour   = ARG(4,6);
  Min    = ARG(5,6);
  Sec    = ARG(6,6);
  
  time(&t);
  ct = localtime(&t);

  return (unify(Year,build_INTEGER(ct->tm_year)) &&
	  unify(Month,build_INTEGER(ct->tm_mon)) &&
	  unify(Day,build_INTEGER(ct->tm_mday))  &&
	  unify(Hour,build_INTEGER(ct->tm_hour)) &&
	  unify(Min,build_INTEGER(ct->tm_min))   &&
	  unify(Sec,build_INTEGER(ct->tm_sec)));
}
  
/*  Example usage: p(A1,A2) */
test(){
  TERM a1,a2,a,b,c,f1,l1,f12;
  char *name_ptr;
  
  /*   prepare Prolog terms */
  a1 = ARG(1,2);
  a2 = ARG(2,2);
  a = build_ATOM("a");
  b = build_ATOM("b");
  c = build_ATOM("c");
  f1 = build_STRUCTURE("f",1);  /* f(1) */
  build_ARG(build_INTEGER(1));
  l1 = build_LIST();            /* [1] */ 
  build_ARG(build_INTEGER(1));
  build_ARG(build_NIL());
  f12 = build_FLOAT(1.2);
  
  /* code for the clauses */
  if (!is_ATOM(a1)) return 0;
  name_ptr = get_NAME(a1);
  switch (*name_ptr){
  case 'a': 
    return (unify(a1,a) ? unify(a2,f1) : 0);
  case 'b': 
    return (unify(a1,b) ? unify(a2,l1) : 0);
  case 'c': 
    return (unify(a1,c) ? unify(a2,f12) : 0);
  default: return 0;
  }
}

c_CallBpFromC(){
  TERM goal;
  goal = ARG(1,1);
  return PcallF(goal);
}

c_START_TRACE(){
  int i;

  trace_toam = 1;
/*
  for (i=1;i<90;i++)
    printf("builtins[%d]=%x\n",i,builtins[i]);
*/
  return 1;
}

c_END_TRACE(){
  int i;

  trace_toam = 0;
/*
  for (i=1;i<90;i++)
    printf("builtins[%d]=%x\n",i,builtins[i]);
*/
  return 1;
}

Cboot() {
  SYM_REC_PTR insert_cpred();
/*
  extern int c_BT();
  extern int c_BT_COUNT();
  extern int c_BT_FIRST();
  extern int c_BT_FALSE();
  extern int c_BT_LAST();
  extern int c_BT_NEXT();
  extern int c_BT_PREV();
  extern int c_BT_SET_FALSE();
  extern int c_BT_SET_FALSE1();
  extern int c_BT_SET_TRUE();
  extern int c_BT_TRUE();
*/
  extern int c_COPY_TERM();
  extern int c_CREATE_ARRAY();
  extern int c_DECREMENTARG();
  extern int c_END_TRACE();
  extern int c_GET_ARRAY();
  extern int c_INCREMENTARG();
  extern int c_SHOW_NONDET_FRAME();
  extern int c_SHOW_SUSP_FRAME();
  extern int c_START_TRACE();
  extern int c_STATISTICS();
  extern int c_STATISTICS0();
  extern int c_UNIFIABLE();
  extern int c_UNGETC();
  extern int c_arg();
  extern int c_clause();
  extern int c_current_predicates();
  extern int c_functor();
  extern int currentTime();
  extern int c_NUMBER_VARS();
  extern int c_NUMBER_VARS();
  extern int c_VARIANT();
  extern int c_callBpFromC();
  extern int c_GET_NONEMPTY_LINE();
  extern int c_FINISH_GET_LINE();
  extern int c_INITIALIZE_TABLE();
  extern int c_OLD_GLOBAL_GET();
  extern int c_OLD_GLOBAL_SET3();
  extern int c_OLD_GLOBAL_SET4();
  extern int c_UNNUMBER_VARS();
  extern int c_SAVE_AR();
  extern int c_WRITE_AR();
  extern int c_TABLE_BUCKET_SIZES();
  extern int c_write_term();
  extern int c_get_line_nos();
  extern int c_update_term_start_line_no();
  extern int test_interface_c_pred();

/*
  insert_cpred("c_BT",2,c_BT);
  insert_cpred("bt_count",2,c_BT_COUNT);
  insert_cpred("bt_first",1,c_BT_FIRST);
  insert_cpred("bt_false",1,c_BT_FALSE);
  insert_cpred("bt_last",1,c_BT_LAST);
  insert_cpred("bt_next",3,c_BT_NEXT);
  insert_cpred("bt_prev",3,c_BT_PREV);
  insert_cpred("bt_set_false",1,c_BT_SET_FALSE);
  insert_cpred("bt_set_flase",2,c_BT_SET_FALSE1);
  insert_cpred("bt_set_true",1,c_BT_SET_TRUE);
  insert_cpred("bt_true",1,c_BT_TRUE);
*/
  insert_cpred("c_COPY_TERM",2,c_COPY_TERM);
  insert_cpred("c_CREATE_ARRAY",2,c_CREATE_ARRAY);
  insert_cpred("c_DECREMENTARG",2,c_DECREMENTARG);
  insert_cpred("c_END_TRACE",0,c_END_TRACE);
  insert_cpred("c_GET_ARRAY",3,c_GET_ARRAY);
  insert_cpred("c_INCREMENTARG",2,c_INCREMENTARG);
  insert_cpred("c_SHOW_NONDET_FRAME",1,c_SHOW_NONDET_FRAME);
  insert_cpred("c_SHOW_SUSP_FRAME",1,c_SHOW_SUSP_FRAME);
  insert_cpred("c_START_TRACE",0,c_START_TRACE);
  insert_cpred("c_STATISTICS",0,c_STATISTICS);
  insert_cpred("c_STATISTICS0",8,c_STATISTICS0);
  insert_cpred("c_UNIFIABLE",2,c_UNIFIABLE);
  insert_cpred("c_UNGETC",1,c_UNGETC);
  insert_cpred("c_arg",3,c_arg);
  insert_cpred("c_clause",6,c_clause);
  insert_cpred("c_current_predicates",1,c_current_predicates);
  insert_cpred("c_functor",3,c_functor);
  insert_cpred("currentTime",6,currentTime);
  insert_cpred("number_vars",3,c_NUMBER_VARS);
  insert_cpred("numbervars",3,c_NUMBER_VARS);
  insert_cpred("variant",2,c_VARIANT);
  insert_cpred("callbp",1,c_CallBpFromC);  
  insert_cpred("c_GET_NONEMPTY_LINE",0,c_GET_NONEMPTY_LINE);
  insert_cpred("c_FINISH_GET_LINE",0,c_FINISH_GET_LINE);
  insert_cpred("c_INITIALIZE_TABLE",0,c_INITIALIZE_TABLE);
  insert_cpred("old_global_get",3,c_OLD_GLOBAL_GET);
  insert_cpred("old_global_set",3,c_OLD_GLOBAL_SET3);
  insert_cpred("old_global_set",4,c_OLD_GLOBAL_SET4);
  insert_cpred("unnumber_vars",2,c_UNNUMBER_VARS);
  insert_cpred("c_SAVE_AR",1,c_SAVE_AR);
  insert_cpred("c_WRITE_AR",1,c_WRITE_AR);
  insert_cpred("table_bucket_sizes",2,c_TABLE_BUCKET_SIZES);
  insert_cpred("c_write_term",1,c_write_term);
  insert_cpred("test_interface_c_pred",2,test_interface_c_pred);
  insert_cpred("c_get_line_nos",2,c_get_line_nos);
  insert_cpred("c_update_term_start_line_no",0,c_update_term_start_line_no);
  Cboot_numbervars();
  Cboot_mic();
  Cboot_assert();
  Cboot_delay();
  Cboot_domain();
#ifdef JAVA
  Cboot_plc(); 
#endif
}


test_interface_c_pred(){
  TERM origX = ARG(1,2);
  TERM X = ARG(2,2);
  TERM call;
  
  call = build_STRUCTURE("test_interface_prolog_pred",2);
  build_ARG(origX);
  build_ARG(X);
  call_bprolog_term(call);
}
  
  

  
