/* Primitives for accessing suspending variables and delayed calls */
#include "cpreds.h"
#include "event.h"
#include "frame.h"

LONG true;

LONG build_delayed_call_on_the_heap(frame)
LONG_PTR frame;
{
  SYM_REC_PTR sym_ptr;
  int arity,i;
  LONG call,arg;

  sym_ptr = (SYM_REC_PTR)FOLLOW((LONG_PTR)AR_REEP(frame)+2);
  arity = GET_ARITY(sym_ptr);
/*
  printf("name=%s arity=%d\n",GET_NAME(sym_ptr),arity);
*/
  for (i = arity; i>0; i--){
    arg = FOLLOW(frame+i);
    if (ISVAR(arg) && ISFREE(arg)){
      FOLLOW(arg) = (LONG)hreg;
      PUSHTRAIL(arg);
      NEW_HEAP_FREE;
    }
  }

  call = ADDTAG(hreg,STR);
  FOLLOW(hreg++) = (LONG)sym_ptr;
  for (i = arity; i>0; i--){
    arg = FOLLOW(frame+i);
    DEREF(arg);
    if (IS_SUSP_VAR(arg))
      NEW_HEAP_NODE(UNTAGGED(arg));
    else
      NEW_HEAP_NODE(arg);
  }
  return call;
}


c_frozen_cf(){
  register LONG var,return_goal,tmp;
  LONG goal;
  LONG_PTR dv_ptr,dcs,list,frozen_cs();

  var = ARG(1,2);
  return_goal = ARG(2,2);
  
  DEREF(var);
  list = hreg;
  goal = (LONG)list;
  *hreg = (LONG)hreg; hreg++;
  if (IS_SUSP_VAR(var)){
    dv_ptr = (LONG_PTR)UNTAGGED(var);
    dcs = (LONG_PTR)DV_ins_cs(dv_ptr);
    list = frozen_cs(dcs,list);
    if (!IS_UN_DOMAIN(dv_ptr)){
      dcs = (LONG_PTR)DV_min_cs(dv_ptr);
      list = frozen_cs(dcs,list);

      dcs = (LONG_PTR)DV_max_cs(dv_ptr);
      list = frozen_cs(dcs,list);

      dcs = (LONG_PTR)DV_dom_cs(dv_ptr);
      list = frozen_cs(dcs,list);
    }
    FOLLOW(list) = nil_sym;
    return unify(return_goal,goal);
  }
  else return unify(return_goal,true);
}

LONG_PTR frozen_cs(cs,Plist)
LONG_PTR cs,Plist;
{
  LONG tmp;

  while (ISLIST((LONG)cs)){
    cs = (LONG_PTR)UNTAGGED(cs);
    tmp = build_delayed_call_on_the_heap((LONG_PTR)UNTAGGED(CS_FRAME(cs)));
    FOLLOW(Plist) = ADDTAG(hreg,LST);
    NEW_HEAP_NODE(tmp); 
    Plist = hreg;hreg++;
    cs = (LONG_PTR)CS_NEXT(cs);
  }
  return Plist;
}

c_frozen_f(){
  LONG P_goal,P_goal_rest;
  LONG cell,tmp;
  LONG_PTR frame;
  
  P_goal = ARG(1,1);
  DEREF(P_goal);
  if (!ISVAR(P_goal)){
    exception = illegal_arguments;
    return -1;
  }

  frame = sfreg;
  while (AR_PREV(frame)!=(LONG)frame) { /* end of chain */
/*
    show_frame(frame);
*/
    tmp = build_delayed_call_on_the_heap(frame);
    P_goal_rest = build_VAR();
    cell = build_LIST();
    build_ARG(tmp);
    build_ARG(P_goal_rest);
    unify(P_goal,cell);
    P_goal = P_goal_rest;
    do {
      frame = (LONG_PTR)AR_PREV(frame);
    }  while (FRAME_IS_DEAD(frame));
  }
  return unify(P_goal,build_NIL());
}

c_susp_var(){
  LONG var = ARG(1,1);
  DEREF(var);
  if (IS_SUSP_VAR(var)) return 1; else return 0;
}

Cboot_delay()
{
  SYM_REC_PTR insert_cpred();
  SYM_REC_PTR insert_cfunc();

  insert_cpred("c_frozen_cf",2,c_frozen_cf);
  insert_cpred("c_frozen_f",1,c_frozen_f);
  insert_cpred("susp_var",1,c_susp_var);
  ADDTAG(insert_cfunc("true",0),ATM);
  true = ADDTAG(insert_cfunc("true",0),ATM);
}

