/* dis.c */

#include "basic.h"
#include "inst.h"
#include "term.h"

/*
#define DEBUG_DIS 
*/
static FILE *filedes;
LONG_PTR cpreg;

dis()
{
#ifdef  DEBUG_DIS
   filedes = stdout;
#else
   filedes = fopen("dump.pil", "w");
#endif
  
   dis_data();
   dis_text();
   fflush(filedes);
   fclose(filedes);
}

dis_data()
{
  SYM_REC_PTR psc_ptr;
   WORD        i;

   fprintf(filedes, "\n/* data below: name, arity, type, and entry */\n\n");
   printf("==> dis_data\n");
   
   for (i = 0; i < BUCKET_CHAIN; ++i) {
     psc_ptr = hash_table[i];
     while (psc_ptr!=NULL) {
       fprintf(filedes, "%x: ", (LONG)psc_ptr);
       writepname(filedes, GET_NAME(psc_ptr), GET_LENGTH(psc_ptr));
       fprintf(filedes, "/%d,\t", GET_ARITY(psc_ptr));
       switch (GET_ETYPE(psc_ptr)) {
       case T_ORDI: fprintf(filedes, "ORDI");  break;
       case T_DYNA: fprintf(filedes, "DYNA");  break;
       case T_PRED: fprintf(filedes, "PRED");  break;
       case C_PRED: fprintf(filedes, "CPRED");  break;
       }
       fprintf(filedes, ",  %x\n", GET_EP(psc_ptr));
       psc_ptr = GET_NEXT(psc_ptr);
     }
   }
  fprintf(filedes, "\n");
}

dis_text()
{
  printf("==> dis_text\n");
  fprintf(filedes, "\n/*  text below  */\n");
   cpreg = inst_begin;

  printf("inst_begin=%x\n",inst_begin);
  do { 
      fprintf(filedes, "\nNew segment below \n\n");
      while (*cpreg != endfile)
         print_inst(filedes, cpreg);
      cpreg++;
   } while (cpreg = (LONG_PTR)*cpreg);  
}

/* these are macros to use lpcreg as the instruction pointer and to
   parse instruction operands into oprnd1, 2, 3 and 4
*/
#define PARSE1 oprnd1 = *lpcreg++; \
               PRINTOP1; fprintf(fd, "\n");

#define PARSE2 oprnd1 = *lpcreg++; oprnd2 = *lpcreg++; \
               PRINTOP1; PRINTOP2; fprintf(fd, "\n");
#define PARSE3 oprnd1 = *lpcreg++; oprnd2 = *lpcreg++; oprnd3 = *lpcreg++; \
               PRINTOP1;PRINTOP2;PRINTOP3; fprintf(fd, "\n");
#define PARSE4 oprnd1 = *lpcreg++; oprnd2 = *lpcreg++; oprnd3 = *lpcreg++; \
               oprnd4 = *lpcreg++;                                         \
               PRINTOP1;PRINTOP2;PRINTOP3; PRINTOP4; fprintf(fd, "\n");

#define PRINTOP1  fprintf(fd, "\t %x",oprnd1);  fflush(stdout)
#define PRINTOP2  fprintf(fd, "\t %x",oprnd2);  fflush(stdout)
#define PRINTOP3  fprintf(fd, "\t %x",oprnd3);  fflush(stdout)
#define PRINTOP4  fprintf(fd, "\t %x",oprnd4);  fflush(stdout)

print_inst(fd, inst_ptr)
FILE     *fd;
LONG_PTR inst_ptr;
{

  LONG_PTR lpcreg;
  LONG      oprnd1, oprnd2, oprnd3, oprnd4;
  LONG     opcode;
  LONG     i;

  lpcreg = inst_ptr;
  if (num_line)
    fprintf(fd, "%x\t", lpcreg);
  opcode = *lpcreg++;

  fprintf(fd, xxopcode[opcode].name);
  if (opcode == tabsize) {
    PARSE1;
    i=oprnd1;
    while (i>0) {
      if (num_line) fprintf(fd, "%x\t",lpcreg);
      PARSE1;
      i--;
    }
  }
  else {
    switch (xxopcode[opcode].size) {
    case 1 : fprintf(fd, "\n");break;
    case 2 : PARSE1; break;
    case 3 : PARSE2; break;
    case 4 : PARSE3; break;
    case 5 : PARSE4; break;
    case 6 : PARSE4; PARSE1; break;
    case 7 : PARSE4; PARSE2; break;
    default: 
      i = xxopcode[opcode].size;
      while (i!=1) { PARSE1; i--;};
    }  
  }
  cpreg = lpcreg;
  
}  /* end of print_inst */



