#include "frame.h"

#define SUSP_START 0
#define SUSP_EXIT 1
#define SUSP_SLEEP 2
#define SUSP_RUN 3
#define SUSP_REENT 4

#define FAIL 0
#define TRUE 1

#define FRAME_IS_START(F) (FOLLOW(AR_STATUS(F))==SUSP_START)
#define FRAME_IS_SLEEP(F) (FOLLOW(AR_STATUS(F))==SUSP_SLEEP)
#define FRAME_IS_DEAD(F)  (FOLLOW(AR_STATUS(F))==SUSP_EXIT)

#define CS_FRAME(cs) *(cs+3)
#define CS_STATUS(cs) *(cs+4)
#define CS_NEXT(cs) *(cs+1)

#define CS_NEXT_ADDR(cs) (cs+1)

#define EVENT_VAR_INS 0x0
#define EVENT_DVAR_INS 0x1
#define EVENT_DVAR_MIN 0x2
#define EVENT_DVAR_MAX 0x3
#define EVENT_DVAR_DOM 0x4

#define ASSIGN_DVAR(dv_ptr,value){ \
    PUSHTRAILB(dv_ptr,DV_var(dv_ptr)); \
    DV_var(dv_ptr) = value; \
    INSERT_TRIGGER_dvar_ins(dv_ptr); } 

#define UPDATE_FIRST(dv_ptr,first){ \
   top = A_DV_first(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = first; \
   INSERT_TRIGGER_min(dv_ptr); } 

#define UPDATE_LAST(dv_ptr,last){ \
   top = A_DV_last(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = last; \
   INSERT_TRIGGER_max(dv_ptr);} 

#define UPDATE_DELTA(dv_ptr,elm){ \
   LONG_PTR list; \
   if (DV_delta(dv_ptr)!=nil_sym){ \
      list = (LONG_PTR)DV_delta(dv_ptr); \
      PUSHTRAIL_h(list); \
      FOLLOW(list) =  ADDTAG((LONG)hreg,LST); \
      *hreg++ = MAKEINT(elm); \
      *hreg = (LONG)hreg; \
      PUSHTRAILB(A_DV_delta(dv_ptr),DV_delta(dv_ptr)); \
      DV_delta(dv_ptr) = (LONG)hreg; \
      NEW_HEAP_FREE; \
   }}

#define UPDATE_SIZE(dv_ptr,size){ \
   top = A_DV_size(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = size;} 

#define UPDATE_TYPE(dv_ptr,type){ \
   top = A_DV_type(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = type;} 

#define LOOKUP_DOMAIN_ELM(dv_ptr,elm,hashtab,size,de_ptr,index,ret_code) \
  if (hashtab==NULL){ \
    if (elm<0 || elm>size) ret_code; \
    de_ptr = dv_ptr+SIZE_OF_DV+elm*SIZE_OF_DE; \
  } else { \
    index = lookup_dm_elm(elm,hashtab,size); \
    if (index>=0) \
      de_ptr = dv_ptr+SIZE_OF_DV+index*SIZE_OF_DE; \
    else ret_code; \
  }

#define LOOKUP_DOMAIN_ELM_1(dv_ptr,elm,hashtab,size,de_ptr,index,ret_code) \
  if (hashtab==NULL){ \
    de_ptr = dv_ptr+SIZE_OF_DV+elm*SIZE_OF_DE; \
  } else { \
    index = lookup_dm_elm(elm,hashtab,size); \
    de_ptr = dv_ptr+SIZE_OF_DV+index*SIZE_OF_DE; \
  }

#define INITIALIZE_DV_CS(cs,H,AR){ \
   cs = ADDTAG(H,LST); \
   FOLLOW(H) = ADDTAG((H+2),STR); ; \
   FOLLOW(H+1) = nil_sym; \
   H += 2; \
   *H++ = (LONG)comma_psc; \
   *H++ = ADDTAG(AR,INT_TAG); \
   *H++ = ADDTAG(AR_STATUS(AR),INT_TAG);}

#define INSERT_SUSP_CALL_DV_CS(addr_cs,H,AR){ \
   *H = ADDTAG((H+2),STR); \
   *(H+1) = FOLLOW(addr_cs); \
   FOLLOW(addr_cs) = ADDTAG(H,LST); \
   H += 2; \
   *H++ = (LONG)comma_psc; \
   *H++ = ADDTAG(AR,INT_TAG); \
   *H++ = ADDTAG(AR_STATUS(AR),INT_TAG); \
}

#define  my_CREATE_SUSP_VAR(op1,H){ \
   FOLLOW(op1) = (LONG)H; \
   PUSHTRAIL(op1); \
   dv_ptr = H; \
   DV_var(dv_ptr) =  ((LONG)H | SUSP); \
   DV_type(dv_ptr) = UN_DOMAIN; \
   H += SIZE_OF_DV; \
   }

#define  my_CREATE_SUSP_VAR_ins(op1,H,AR){ \
   my_CREATE_SUSP_VAR(op1,H); \
   DV_min_cs(dv_ptr) = nil_sym; \
   DV_max_cs(dv_ptr) = nil_sym; \
   DV_dom_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_ins_cs(dv_ptr),H,AR);}

#define  my_CREATE_SUSP_VAR_max(op1,H,AR){ \
   my_CREATE_SUSP_VAR(op1,H); \
   DV_ins_cs(dv_ptr) = nil_sym; \
   DV_min_cs(dv_ptr) = nil_sym; \
   DV_dom_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_max_cs(dv_ptr),H,AR);}

#define  my_CREATE_SUSP_VAR_min(op1,H,AR){ \
   my_CREATE_SUSP_VAR(op1,H); \
   DV_ins_cs(dv_ptr) = nil_sym; \
   DV_max_cs(dv_ptr) = nil_sym; \
   DV_dom_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_min_cs(dv_ptr),H,AR);}

#define  my_CREATE_SUSP_VAR_dom(op1,H,AR){ \
   my_CREATE_SUSP_VAR(op1,H); \
   DV_ins_cs(dv_ptr) = nil_sym; \
   DV_min_cs(dv_ptr) = nil_sym; \
   DV_max_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_dom_cs(dv_ptr),H,AR);}

#define my_INSERT_SUSP_CALL(addr_cs,H,AR){ \
   PUSHTRAILB(addr_cs,FOLLOW(addr_cs)); \
   INSERT_SUSP_CALL_DV_CS(addr_cs,H,AR); \
}

#define my_INSERT_SUSP_CALL_ins(op,H,AR){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_ins_cs(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

#define my_INSERT_SUSP_CALL_min(op,H,AR){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_min_cs(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

#define my_INSERT_SUSP_CALL_max(op,H,AR){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_max_cs(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

#define my_INSERT_SUSP_CALL_dom(op,H,AR){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_dom_cs(dv_ptr); \
   PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

