#include  <stdio.h>
#include "basic.h"
#include "term.h"
#include "macro.h"

#define CAR 1
#define CDR 0
#define MAXFILES 20

#define EMIT4(op){ \
  b4 = op & 0xff; \
  op >>= 8; \
  b3 = op & 0xff; \
  op >>= 8; \
  b2 = op & 0xff; \
  op >>= 8; \
  b1 = op; \
  putc(b1,curr_out);putc(b2,curr_out);putc(b3,curr_out);putc(b4,curr_out);}

static int         n, a;
static WORD        fileerrors = 0;   /* abort, or not on file errors */
static SYM_REC_PTR user_sym_ptr, stderr_sym_ptr, sym_ptr;

static FILE        *tempfile;
static CHAR        s[256];

static LONG        user_word, con_word, stderr_word;

struct ftab_ent
{
   int   inout;      /* 1 if input, 0 if output */
   LONG  p_ptr;      /* tagged ptr to sym_ptr of constant */
   FILE *fdes;       /* file descriptor for this constant */
};

/* table of open files; 0 is always stdin, 1 is always stdout, 
   2 is always stderr */
static struct ftab_ent file_table[MAXFILES];
static int file_tab_end = 0; /* last used entry in file_table */

/* index of current input (output) stream in file_table */
static int in_file_i, out_file_i;
FILE *curr_in, *curr_out;
int curr_line_no,term_start_line_no;
extern int lastc;
extern SYM_REC_PTR insert();
extern eval_arith();

static struct hostent *hp;

get_file_name(op)
LONG op;
{
  CHAR s1[256];
  int i;
  CHAR_PTR s2,getenv();
  
  namestring(GET_SYM_REC(op),s1);

  if (*s1 == '~'){
    s2 = getenv("HOME");
    if (s2==NULL){
      fputs("the environment variable HOME is not set\n",stderr);exit(1);
    }
    if (*(s1+1) == '/'){
      scat(s2,&s1[1],s); return 1;
    }
    else {
      i = strlen(s2);
      i--;
      while  (*(s2 + i) != '/'){
	*(s2+i) = '\0';
	i--;
      }
      scat(s2,&s1[1],s); 
      return 1;
    }
  }
  else{
    strcpy(s,s1);
    return 1;
  }
}
  
writepname(file, name_ptr, length)
FILE     *file;
CHAR_PTR name_ptr;
WORD     length;
{
   WORD i, slen;
   CHAR ch;

/*
   slen = length > 80 ? 80 : length; 
   for (i = 1; i <= slen; ++i) {
	ch = *name_ptr++;
	putc(((ch < ' ' && ch != '\n' && ch != '\t') ? ' ' : ch), file);
	}
*/
   fputs(name_ptr,file);
   fflush(file); 
}

writeqname(file, name_ptr, length)
FILE     *file;
CHAR_PTR name_ptr;
WORD     length;
{
   WORD i, need_to_quote;
   CHAR ch;

   ch = *name_ptr;
   if (ch >= 'a' && ch <= 'z')
      need_to_quote = 0;
   else need_to_quote = 1;
   if (!need_to_quote) {
      i = 1;
      while (i < length) {
	 ch = *(name_ptr+i);
	 if (!((ch >= '0' && ch <= '9') ||
	       (ch >= 'A' && ch <= 'Z') ||
	       (ch == '_') ||
	       (ch >= 'a' && ch <= 'z'))) {
            need_to_quote = 1;    /* quote if name contains spl chars */
            break;
	 }
	 else i++;
      }
   }
   if (need_to_quote)
      fprintf(file, "'");
   for (i = 1; i <= length; ++i) {
      if (need_to_quote && *name_ptr == '\'')
	 fprintf(file, "'");
      putc(((*name_ptr > '\0' && *name_ptr < ' ' && *name_ptr != '\n' && *name_ptr != '\t') ? 
	    ' ' : *name_ptr), file);
      name_ptr++;
   }
   if (need_to_quote)
     fprintf(file, "'");
   fflush(file); 
 }

printterm(term, car)
LONG term;
BYTE car;
{
   WORD              i, arity;
   SYM_REC_PTR       sym_ptr;
   register LONG_PTR top;
   double floatval();
   
   SWITCH_OP(term,printterm_1,
	     {printf("_%x", term);},

	     {if (ISATOM(term)){
	       sym_ptr = GET_ATM_SYM_REC(term);
	       writepname(stdout, GET_NAME(sym_ptr), GET_LENGTH(sym_ptr));
	     }
	     else printf("%d", INTVAL(term));},

	     {UNTAG(term);
	      if (car)
		printf("[");
	      printterm(FOLLOW(term), CAR);
	      term = FOLLOW(term + 4);
	      SWITCH_OP(term,printterm_2,
			{},
			if (ISNIL(term)) {    /* term is the 'nil' constant */
			  printf("]");
			  fflush(stdout);
			  return 1;
			},
			{printf(",");
			 printterm(term, CDR);
			 return 1;},
			{},
			{});
	      /* vertical bar case */
	      printf("|");
	      printterm(term, CAR);
	      printf("]");
	      fflush(stdout); },

	     {if (ISFLOAT(term)){
	       fprintf(curr_out,"%.6g",floatval(term));
	       return 1;
	     }
	     else {
	       sym_ptr = GET_STR_SYM_REC(term);
	       writepname(stdout, GET_NAME(sym_ptr), GET_LENGTH(sym_ptr));
	       arity = GET_ARITY(sym_ptr);
	       /* structure */
	       printf("(");
	       UNTAG(term);
	       for (i = 1; i <= arity; i++) {
		 printterm(term += 4, CAR);
		 if (i < arity)                   /* not at end of struct */
		   printf(",");
	       }
	       printf(")");
	       fflush(stdout); }},
	     
	     {printf("_%x",term);});
   return 1;
 }

get_file_index(cword, io)
LONG cword;
int  io;
{
   int i;

   for (i = 0; i <= file_tab_end; i++) {
      if (file_table[i].p_ptr == cword)
         if (io == file_table[i].inout || io > 1)
            return i;
   }
   return -1;
}

next_file_index()
{
  int i;

  for (i = 3; i <= file_tab_end; i++) 
    if (file_table[i].fdes == NULL) return i;
  file_tab_end++;
  if (file_tab_end>=MAXFILES){
    exception = out_of_range;
    return -1;
  }
  return file_tab_end;
}

release_file_index(i)
int i;
{
  file_table[i].fdes = NULL;  
  file_table[i].p_ptr = nil_sym;
  return 1;
}
  
b_NORMAL_ATOM_c(op)
register LONG op;
{
  SYM_REC_PTR sym_ptr;
  int i,length;
  char ch,*name_ptr;
  
  DEREF(op);
  sym_ptr = GET_SYM_REC(op);
  length = GET_LENGTH(sym_ptr);
  name_ptr = GET_NAME(sym_ptr);
  
  ch = *name_ptr;
  if (!(ch >= 'a' && ch <= 'z'))
    return 0;

  i = 1;
  while (i < length) {
    ch = *(name_ptr+i);
    if (!((ch >= '0' && ch <= '9') ||
	  (ch >= 'A' && ch <= 'Z') ||
	  (ch == '_') ||
	  (ch >= 'a' && ch <= 'z'))) 
      return 0;
    else i++;
  }
  return 1;
}
  
b_WRITENAME_c(op)
register LONG     op;
{
  register LONG_PTR top,dv_ptr;
  double floatval();
  
  SWITCH_OP(op,writename_1,
	    {fprintf(curr_out, "_%x", op);},
	    {if (ISATOM(op)){
	      sym_ptr = GET_ATM_SYM_REC(op);
	      writepname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	    }
	    else fprintf(curr_out, "%d", INTVAL(op));},
	    {fprintf(curr_out, ".");},
	    {if (ISFLOAT(op)){
	      fprintf(curr_out,"%lf",floatval(op));
	    }
	    else {
	      sym_ptr = GET_STR_SYM_REC(op);
	      writepname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	    }},
	    {dv_ptr = (LONG_PTR)UNTAGGED(op);
	     fprintf(curr_out, "_%x", op);
	     if (!IS_UN_DOMAIN(dv_ptr))
	       fprintf(curr_out, ":[%d,%d]", DV_first(dv_ptr),DV_last(dv_ptr));;});

  return 1;
}

b_WRITE_QUICK_c(op)
register LONG op;
{
  double floatval();
  LONG_PTR dv_ptr;

  SWITCH_OP(op,write_quick_1,
	    {fprintf(curr_out, "_%x", op);},
	    {if (ISATOM(op)){
	      sym_ptr = GET_ATM_SYM_REC(op);
	      writepname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	    }
	    else fprintf(curr_out, "%d", INTVAL(op));},
	    {return 0;},
	    {if (ISFLOAT(op)) fprintf(curr_out,"%lf",floatval(op));
	    else  return 0;},
	    {dv_ptr = (LONG_PTR)UNTAGGED(op);
	     fprintf(curr_out, "_%x", op);
	     if (!IS_UN_DOMAIN(dv_ptr))
	       fprintf(curr_out, ":[%d,%d]", DV_first(dv_ptr),DV_last(dv_ptr));;});
  return 1;
}
  
b_WRITEQNAME_c(op)
register LONG     op;
{
  double floatval();
  register LONG_PTR top;
  
  SWITCH_OP(op,writeqname_1,
	    {fprintf(curr_out, "_%x", op);},
	    {if (ISATOM(op)){
	      sym_ptr = GET_ATM_SYM_REC(op);
	      writeqname(curr_out, GET_NAME(sym_ptr), GET_LENGTH(sym_ptr));
	    }
	    else fprintf(curr_out, "%d", INTVAL(op));},
	    {fprintf(curr_out, ".");},
	    {if (ISFLOAT(op)) fprintf(curr_out,"%lf",floatval(op));
	     else {
	       sym_ptr = GET_STR_SYM_REC(op);
	       writeqname(curr_out, GET_NAME(sym_ptr), GET_LENGTH(sym_ptr));
	     }},
	    {fprintf(curr_out, "_%x", op);});
  return 1;
}

b_WRITEQ_QUICK_c(op)
register LONG op;
{
  double floatval();

  SWITCH_OP(op,writeqquick_1,
	    {fprintf(curr_out, "_%x", op);},
	    {if (ISATOM(op)){
	      sym_ptr = GET_ATM_SYM_REC(op);
	      writeqname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	    }
	    else fprintf(curr_out, "%d", INTVAL(op));},
	    {return 0;},
	    {if (ISFLOAT(op)) fprintf(curr_out,"%q",floatval(op));
	    else  return 0;},
	    {fprintf(curr_out, "_%x", op);});
  return 1;
}

b_NL()
{
  putc('\n',curr_out);
  fflush(curr_out);
  return 1;
}

b_PUT_c(op)
register LONG op;
{
  LONG res;
  
  DEREF(op);
  if (ISINT(op)) goto b_put;
  if ((eval_arith(op,&res)<0) || (!ISINT(res))) return -1;
  op = res;
 b_put:
  putc(INTVAL(op),curr_out);
  return 1;
}

b_TAB_c(op)
register LONG     op;
{
  register LONG_PTR top;
  LONG res;

  DEREF(op);
  if (ISINT(op)) goto b_tab;
  if ((eval_arith(op,&res)<0) || (!ISINT(res))) return -1;
  op = res;
 b_tab:
  op = INTVAL(op);
  if (op < 0) 
    return 1;
  for ( ; op > 0; op--)
      putc(' ', curr_out);
  return 1;
}

b_GET0_f(op)
register LONG op;
{
  int n;

  DEREF(op);
  n = getc(curr_in);

  if (n == EOF)
    clearerr(curr_in);

  ASSIGN_f(op,MAKEINT(n));
  return 1;
}

c_UNGETC(op)
LONG op;
{
  op = ARG(1,1);
  DEREF(op);
  lastc = INTVAL(op);
  return 1;
}

b_GET_f(op)
register LONG op;
{
  DEREF(op);
  do {
    n = getc(curr_in);
  } while (n != EOF && (n <= 32 || n >= 127));
  if (n == EOF) {
    clearerr(curr_in);
  }

  ASSIGN_f(op,MAKEINT(n));
  return 1;
}

b_SEE_c(fop)
register LONG fop;
{
  register LONG_PTR top;
  int      temp_in_file_i;

  DEREF(fop);
  temp_in_file_i = get_file_index(fop, 1);
  if (temp_in_file_i < 0) {    /* not in table */
    get_file_name(fop);
#ifdef WIN32
    tempfile = fopen(s, "rb");
#else
    tempfile = fopen(s, "r");
#endif
    if (tempfile==NULL) {
      exception = illegal_file;
      return -1;
    }
    curr_line_no = 1;
    term_start_line_no = 1;
    in_file_i = next_file_index();
    if (in_file_i<0) return -1;
    file_table[in_file_i].inout = 1;
    file_table[in_file_i].p_ptr = fop;
    file_table[in_file_i].fdes  = tempfile;
  }
  else 
    in_file_i = temp_in_file_i;    /* take it from table */
  curr_in = file_table[in_file_i].fdes;
  return 1;
}
  

b_SEEN()
{
  if (in_file_i > 2) {
    fclose(curr_in);
    release_file_index(in_file_i);
  }
  in_file_i = 0;    /* reset to user */
  curr_in = file_table[in_file_i].fdes;
  return 1;
}

b_SEEING_f(temp)
register LONG temp;
{
  ASSIGN_f(temp,file_table[in_file_i].p_ptr);
  return 1;
}

/* fop: file name */
/* sop: 0 -> open `w'-write; 1 -> open `a'-append */
b_TELL_cc(fop,sop)  
register LONG     sop, fop;
{

  register LONG_PTR top;
  int      temp_out_file_i;

  DEREF(fop);DEREF(sop);
  temp_out_file_i = get_file_index(fop, 0);

   if (temp_out_file_i < 0) {                 /* not in table */
     get_file_name(fop);
     if(INTVAL(sop)==1)
#ifdef WIN32       
       tempfile = fopen(s, "ab");
#else
       tempfile = fopen(s, "a");
#endif
     else
#ifdef WIN32
       tempfile = fopen(s, "wb");
#else
       tempfile = fopen(s, "w");
#endif
     if (tempfile==NULL) {
       exception = illegal_file;
       return -1;
     }
     temp_out_file_i = next_file_index();
     if (temp_out_file_i<0) return -1;
     file_table[temp_out_file_i].inout = 0;
     file_table[temp_out_file_i].p_ptr = fop;
     file_table[temp_out_file_i].fdes  = tempfile;
   }
  out_file_i = temp_out_file_i;
  curr_out = file_table[out_file_i].fdes;
  return 1;
}

b_TOLD()
{
   if (out_file_i > 2) {
     fclose(file_table[out_file_i].fdes);
     release_file_index(out_file_i);
   }
   out_file_i = 1;       /* reset to user */
   curr_out = file_table[out_file_i].fdes;
   return 1;
 }

b_TELLING_f(temp)  /* arg1: unified with the current out put file name */
register LONG  temp;
{
  
  ASSIGN_f(temp,file_table[out_file_i].p_ptr);
  return 1;
}

b_FILEERRORS()
{
   fileerrors = 1;
}

b_NOFILEERRORS()
{
   fileerrors = 0;
}

/* fop: file name */
/* sop: 0 -> read; 1 -> write; 2 -> append*/
b_OPEN_ccf(fop,sop,Index)  
register LONG     sop, fop,Index;
{         
  register LONG_PTR top;
  int index,mode,inout;
   
  DEREF(sop);
  DEREF(fop);
  mode = INTVAL(sop);
   if (mode==0) 
     inout=1;
   else 
     inout=0;
   index = get_file_index(fop, inout);
   
   if (index < 0 || (index>=2 && file_table[index].inout!=inout)) {                 /* not in table */
     get_file_name(fop);
     switch (mode) {
     case 0:
#ifdef WIN32
       tempfile = fopen(s,"rb");
#else
       tempfile = fopen(s,"r");
#endif
       break;
     case 1:
#ifdef WIN32
       tempfile = fopen(s, "wb");
#else
       tempfile = fopen(s, "w");
#endif
       break;
     case 2:
#ifdef WIN32
       tempfile = fopen(s, "ab");
#else
       tempfile = fopen(s, "a");
#endif
       break;
     default:
       return -1;
     }
     if (!tempfile) {
       return 0;
     }
     index = next_file_index();
     if (index<0) return -1;
     file_table[index].inout = inout;
     file_table[index].p_ptr = fop;
     file_table[index].fdes  = tempfile;
   } 
  ASSIGN_f(Index, MAKEINT(index));
  return 1;
}

b_CLOSE_c(Index)
register LONG     Index;
{
  register LONG_PTR top;
  int     i;
  
  DEREF(Index);
  i = INTVAL(Index);
  if (i > 2) {    /* not user, stderr */
    fclose(file_table[i].fdes);
    release_file_index(i);
    if (file_table[INTVAL(Index)].inout==1){
      in_file_i = 0;
      curr_in = stdin;
    }
    else {
      in_file_i =1;
      curr_out = stdout;
    }
    return 1;
  }
}

file_init(){
    LONG temp;

    user_sym_ptr = insert("user", 4, 0);
    user_word = ADDTAG(user_sym_ptr, ATM);

    stderr_sym_ptr = insert("stderr", 6, 0);
    stderr_word = ADDTAG(stderr_sym_ptr,ATM);

    file_table[0].inout = 1;
    file_table[0].p_ptr = user_word;
    file_table[0].fdes  = stdin;
    in_file_i = 0;
    curr_in   = stdin;

    file_table[1].inout = 0;
    file_table[1].p_ptr = user_word;
    file_table[1].fdes  = stdout;
    out_file_i = 1;
    curr_out   = stdout;

    file_table[2].inout = 0;
    file_table[2].p_ptr = stderr_word;
    file_table[2].fdes = stderr;

    file_tab_end = 2;
}

b_ACCESS_ccf(op1,op2,op3)
register LONG     op1, op2,op3;
{
  int mode, r;
  char name[256];
  register LONG_PTR top;
  SYM_REC_PTR sym_ptr;
  
  DEREF(op1);DEREF(op2);
  if (ISATOM(op1)) {
    get_file_name(op1);
  }
  else {
    exception = atom_expected;
    return -1;
  }
  if (ISINT(op2)) mode = INTVAL(op2);
  else {
    exception = integer_expected;
    return -1;
  };
  r = access(s, mode);
  ASSIGN_f(op3,MAKEINT(r));
  return 1;
}

c_write_term(){
  LONG op;

  op = ARG(1,1);
  write_term(op);
  return 1;
}

write_term(op)
LONG op;
{
  SYM_REC_PTR sym_ptr;
  LONG op1;
  int  i,arity;
  double floatval();

  SWITCH_OP(op,write_term_1,
	    {fprintf(curr_out,"_%x",op);},

	    {if (ISATOM(op)){
	      sym_ptr = GET_ATM_SYM_REC(op);
	      writepname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	    }
	    else fprintf(curr_out,"%d",INTVAL(op));},

	    {fprintf(curr_out,"["); return write_list(op);},

	    {if (ISFLOAT(op)){
	      fprintf(curr_out,"%lf",floatval(op));
	    }
	    else {
	      sym_ptr = GET_STR_SYM_REC(op);
	      writepname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	      if (GET_ARITY(sym_ptr)>0) {
		fprintf(curr_out,"(");
		UNTAG(op);
		arity = GET_ARITY(sym_ptr);
		for (i=1;i<=arity;i++) {
		  op1 = *((LONG_PTR)op+i);
		  DEREF(op1);
		  write_term(op1);
		  if (i<arity)
		    fprintf(curr_out,",");
		}
		fprintf(curr_out,")");
	      }}},

	    {print_dvar(UNTAGGED(op));});
  return 1;
}

write_list(op) 
LONG op;
{
  LONG temp;
  
  GET_CAR(temp,op);
  if (!write_term(temp))
    return 0;
  GET_CDR(temp,op);
  if (ISLIST(temp)) {
    fprintf(curr_out,",");
    return write_list(temp);
  }
  else if (ISVAR(temp)) {
    fprintf(curr_out,"|");
    if (!write_term(temp))
      return 0;
    fprintf(curr_out,"]");
  }
  else
    fprintf(curr_out,"]");
  return 1;
}

write_termq(op)
LONG op;
{
  SYM_REC_PTR sym_ptr;
  LONG op1;
  int  i,arity;
  double floatval();

  SWITCH_OP(op,write_termq_1,
	    {fprintf(curr_out,"_%x",op);},
	    {if (ISATOM(op)){
	      sym_ptr = GET_ATM_SYM_REC(op);
	      writepname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	    }
	    else fprintf(curr_out,"%d",INTVAL(op));},
	    {fprintf(curr_out,"[");
	     write_listq(op);},
	    {if (ISFLOAT(op)){
	      fprintf(curr_out,"%lf",floatval(op));
	    }
	    else {
	      sym_ptr = GET_STR_SYM_REC(op);
	      writepname(curr_out,GET_NAME(sym_ptr),GET_LENGTH(sym_ptr));
	      if (GET_ARITY(sym_ptr)>0) {
		fprintf(curr_out,"(");
		UNTAG(op);
		arity = GET_ARITY(sym_ptr);
		for (i=1;i<=arity;i++) {
		  op1 = *((LONG_PTR)op+i);
		  DEREF(op1);
		  write_termq(op1);
		  if (i<arity)
		    fprintf(curr_out,",");
		}
		fprintf(curr_out,")");
	      }}},
	    {fprintf(curr_out,"_%x",op);});
  return 1;
}
 
write_listq(op) 
LONG op;
{
  LONG temp;

  GET_CAR(temp,op);
  write_term(temp);
  GET_CDR(temp,op);
  if (ISLIST(temp)) {
    fprintf(curr_out,",");
    write_listq(temp);
  }
  else if (ISVAR(temp)) {
    fprintf(curr_out,"|");
    write_termq(temp);
    fprintf(curr_out,"]");
  }
  else
    fprintf(curr_out,"]");
}


b_WRITE_IMAGE_c(op)
register LONG op;
{
  return write_image(op);
}

write_image(op)
LONG op;
{
  LONG temp;
  SYM_REC_PTR sym_ptr;
  LONG op1;
  int  i,arity;

  DEREF(op);
  switch (TAG(op)) {
  case REF :
    fprintf(curr_out,"var      %x\n",op);
    break;
  case LST :
    fprintf(curr_out,"list     %x\n",UNTAGGED(op));
    UNTAG(op);
    op1 = *(LONG_PTR)op;
    DEREF(op1);
    fprintf(curr_out,"car      %x\n",op1);
    op1 = *((LONG_PTR)op+1);
    DEREF(op1);
    fprintf(curr_out,"cdr      %x\n",op1);
    op1 = *(LONG_PTR)op;
    DEREF(op1);
    write_image(op1);
    op1 = *((LONG_PTR)op+1);
    DEREF(op1);
    write_image(op1);
    break;
  case ATM :
    if (ISATOM(op))
      fprintf(curr_out,"atom     %x\n",UNTAGGED(op));
    else 
      fprintf(curr_out,"int      %d\n",INTVAL(op));
    break;
  case STR:
    fprintf(curr_out,"str      %x\n",UNTAGGED(op));
    sym_ptr = GET_STR_SYM_REC(op);
    UNTAG(op);
    arity = GET_ARITY(sym_ptr);
    for (i=1;i<=arity;i++) {
      op1 = *((LONG_PTR)op+i);
      DEREF(op1);
      fprintf(curr_out,"%d-arg    %x\n",i,op1);
    }
    for (i=1;i<=arity;i++) {
      op1 = *((LONG_PTR)op+i);
      DEREF(op1);
      write_image(op1);
    }
    break;
  }
  return 1;
}



/**************** for ISO Prolog *********************/
b_CURRENT_INPUT_f(Index)
register LONG Index;
{

  ASSIGN_f(Index,MAKEINT(in_file_i));
  return 1;
}

b_CURRENT_OUTPUT_f(Index)
register LONG Index;
{
  ASSIGN_f(Index,MAKEINT(out_file_i));
  return 1;
}

b_SET_INPUT_c(Index)
register LONG Index;
{
  DEREF(Index);
  in_file_i = INTVAL(Index);
  if (file_table[in_file_i].inout!=1) return 0;
  curr_in = file_table[in_file_i].fdes;
  return 1;
}

b_SET_OUTPUT_c(Index)
register LONG Index;
{
  DEREF(Index);
  out_file_i = INTVAL(Index);
  if (file_table[out_file_i].inout!=0) return 0;
  curr_out = file_table[out_file_i].fdes;
  return 1;
}
  
b_FLUSH_OUTPUT(){
  fflush(curr_out);
  return 1;
}

/********* functions called by asm.pl *********/
b_ASPN_c(op1)
register LONG op1;
{
  register LONG op;
  register BYTE b1,b2,b3,b4;
  
  DEREF(op1);
  op = INTVAL(op1);
  EMIT4(op);
  return 1;
}

b_ASPN2_cc(op1,op2)
register LONG op1,op2;
{
  register LONG op;
  register BYTE b1,b2,b3,b4;

  DEREF(op1);
  op = INTVAL(op1);
  EMIT4(op);
  DEREF(op2);
  op = INTVAL(op2);
  EMIT4(op);
  return 1;
}

b_ASPN3_ccc(op1,op2,op3)
register LONG op1,op2,op3;
{
  register LONG op;
  register BYTE b1,b2,b3,b4;

  DEREF(op1);
  op = INTVAL(op1);
  EMIT4(op);
  DEREF(op2);
  op = INTVAL(op2);
  EMIT4(op);
  DEREF(op3);
  op = INTVAL(op3);
  EMIT4(op);
  return 1;
}

b_ASPN4_cccc(op1,op2,op3,op4)
register LONG op1,op2,op3,op4;
{
  register LONG op;
  register BYTE b1,b2,b3,b4;

  DEREF(op1);
  op = INTVAL(op1);
  EMIT4(op);
  DEREF(op2);
  op = INTVAL(op2);
  EMIT4(op);
  DEREF(op3);
  op = INTVAL(op3);
  EMIT4(op);
  DEREF(op4);
  op = INTVAL(op4);
  EMIT4(op);
  return 1;
}

aspn(){
  LONG op;
  register BYTE b1,b2,b3,b4;

  op = ARG(1,1);
  DEREF(op);
  op = INTVAL(op);
  EMIT4(op);
  return 1;
}

c_get_line_nos(){
  LONG curr_no,start_no;

  curr_no = ARG(1,2);
  start_no = ARG(2,2);
  
  unify(curr_no,MAKEINT(curr_line_no));
  unify(start_no,MAKEINT(term_start_line_no));
  return 1;
}
  
c_update_term_start_line_no(){
  term_start_line_no = curr_line_no;
  return 1;
}
  


