#define AR_AR_ADDR(ar)                  ar
#define AR_CPS_ADDR(ar)                 (ar-1)
#define AR_TOP_ADDR(ar)                 (ar-2)
#define AR_BTM_ADDR(ar)                 (ar-3)
#define AR_B_ADDR(ar)                   (ar-4)
#define AR_CPF_ADDR(ar)                 (ar-5)
#define AR_H_ADDR(ar)                   (ar-6)
#define AR_T_ADDR(ar)                   (ar-7)
#define AR_SF_ADDR(ar)                  (ar-8)

#define AR_REEP_ADDR(ar)                (ar-4)
#define AR_PREV_ADDR(ar)                (ar-5)
#define AR_STATUS_ADDR(ar)              (ar-6)

#define AR_TABLE_ADDR(ar)               (ar-9)
#define AR_CURRA_ADDR(ar)               (ar-10)
#define AR_PIONEER_ADDR(ar)             (ar-11)

#define AR_AR(ar)                  *ar
#define AR_CPS(ar)                 *(ar-1)
#define AR_TOP(ar)                 *(ar-2)
#define AR_BTM(ar)                 *(ar-3)
#define AR_B(ar)                   *(ar-4)
#define AR_CPF(ar)                 *(ar-5)
#define AR_H(ar)                   *(ar-6)
#define AR_T(ar)                   *(ar-7)
#define AR_SF(ar)                  *(ar-8)

#define AR_REEP(ar)                *(ar-4)
#define AR_PREV(ar)                *(ar-5)
#define AR_NEXT(ar)                *(ar-5)
#define AR_STATUS(ar)              *(ar-6)

#define AR_TABLE(ar)               *(ar-9)
#define AR_CURRA(ar)               *(ar-10)
#define AR_PIONEER(ar)             *(ar-11)

/************************************************/
#define AR_IS_FLAT    0x0
#define AR_IS_FLAT_B  0x1
#define AR_IS_SUSP    0x2
#define AR_IS_NONDET  0x80000000
#define AR_IS_TABLE   0x80000001

/************************************************/
#define AllocateFromTableArea(ptr,size){ \
  if (tareg+size>=tableAreaBottom) quit("Table area overflow\n"); \
  ptr = tareg; \
  tareg += size; }

/************************************************
subgoalTable -> bucket[0]
                 ...
       	        bucket[subgoalTableBucketSize-1]
subgoalTableEntry ->
                NEXT
                ANSWERTABLE
                AR
                SYM
                args
************************************************/
#define GT_NEXT(tab) FOLLOW((LONG_PTR)tab)
#define GT_ANSWERTABLE(tab) FOLLOW((LONG_PTR)(tab)+1)
#define GT_AR_ADDR(tab) ((LONG_PTR)(tab)+2)
#define GT_AR(tab) FOLLOW((LONG_PTR)(tab)+2)
#define GT_SYM(tab) FOLLOW((LONG_PTR)(tab)+3)
#define GT_ARG_ADDR(tab) ((LONG_PTR)(tab)+4)
#define AllocateSubgoalTableEntry(ptr,arity) AllocateFromTableArea(ptr,arity+4)
#define ReleaseSubgoalTableEntry(ptr) tareg = ptr
#define SetCompletionBit(ptr) GT_ANSWERTABLE(ptr) = (GT_ANSWERTABLE(ptr) | 0x1)
                
/************************************************
answerTable ->  bucket[0]
                 ...
       	        bucket[answerTableBucketSize-1]
	        FIRST
	        LAST
                Dummy
************************************************/
#define ANSWERTABLE_FIRST(tab) FOLLOW((LONG_PTR)(tab)+answerTableBucketSize)
#define ANSWERTABLE_LAST_ADDR(tab) ((LONG_PTR)(tab)+answerTableBucketSize+1)
#define ANSWERTABLE_LAST(tab) FOLLOW((LONG_PTR)(tab)+answerTableBucketSize+1)
#define ANSWERTABLE_DUMMY_ADDR(tab) ((LONG_PTR)(tab)+answerTableBucketSize+2)
#define ANSWERTABLE_DUMMY(tab) FOLLOW((LONG_PTR)(tab)+answerTableBucketSize+2)

/************************************************
   answer -> next_in_table
          -> next_in_chain
          -> A1
          -> ...
	  -> An
************************************************/
#define ANSWER_NEXT_IN_TABLE(answer) FOLLOW((LONG_PTR)answer)
#define ANSWER_NEXT_IN_CHAIN(answer) FOLLOW((LONG_PTR)answer+1)
#define ANSWER_ARG_ADDR(answer) ((LONG_PTR)answer+2)

#define REVISED 0x1
#define TABLE_COMPLETE 0x1

#define AddRevisedBit(word) ((LONG)(word) | REVISED)
#define RemoveRevisedBit(word) ((LONG)(word) & VAL_MASK1)

#define RevisedAnswerTable(ptr) (ANSWERTABLE_LAST(ptr) & REVISED)
#define ResetRevisedAnswerTable(ptr) ANSWERTABLE_LAST(ptr) = RemoveRevisedBit(ANSWERTABLE_LAST(ptr)) 

#define IS_PIONEER(ar) (AR_PIONEER(ar)==(LONG)ar)

#define RECOMPUTATION_BIT 0x2
#define IS_INSIDE_RECOMPUTATION(op) (((LONG)op & RECOMPUTATION_BIT) == RECOMPUTATION_BIT)
#define ADD_RECOMPUTATION_BIT(op) (((LONG)op | RECOMPUTATION_BIT))

#define NO_RESERVED_SLOTS(f,type,no){ \
        type = (AR_BTM(f) & TAG_MASK); \
        if (type==AR_IS_FLAT) no = 4; \
        else if (type==AR_IS_FLAT_B) no = 5; \
        else if (type==AR_IS_SUSP) no = 7; \
        else if (type==AR_IS_NONDET) no = 9; \
        else if (type==AR_IS_TABLE) no = 11; \
}


