/* init.c */

#include "frame.h"
#include "cpreds.h"
#include "inst.h"
#ifndef WIN32
#include <stdlib.h>
#endif
#include <string.h>

#define SUSP_SLEEP 2

LONG  maxmem    = 2000000;  
LONG  maxpspace = 2000000;
LONG  maxtrail  = 500000;
LONG  tableAreaSize = 200000;
LONG  maxmemb;

extern char *malloc();
extern char *getenv();

LONG nilsym = 1;
/****************************************************************************/


init_toam(argc, argv)
int  argc;
char *argv[];
{
   WORD     i, itmp; 
   LONG     tempint;
   SYM_REC_PTR temp,insert();
   CHAR     c;
   CHAR_PTR charp;

   for (i = 0; i < BUCKET_CHAIN; i++) {
     hash_table[i] = (SYM_REC_PTR)NULL;
   }

   disassem = num_line = 0;
/*
   if (argc == 1)
     quit("Usage: bprolog [-Ttdns] [-p p_size] [-s st_size] [-b tr_size] bc_file ...\n");
*/
   for (i = 1; i < argc; i++) {
     if (*argv[i] == '-') {
	charp = argv[i];
	if (c = *++charp) {
	  switch (c) {
	  case 't': i++;
	    sscanf(argv[i], "%d", &tableAreaSize);
	    break;
	  case 'T': 
	  case 'n': num_line = 1;
	    break;
	  case 'd': disassem = 1;
	    break;
	  case 's': i++;
	    sscanf(argv[i], "%d", &maxmem);
	    break;
	  case 'p': i++;
	    sscanf(argv[i], "%d", &maxpspace);
	    break;
	  case 'b': i++;
	    sscanf(argv[i], "%d", &maxtrail);
	    break;
	  default: i++;
	  }  
	}  
      }  
   }  

   rreg = (LONG_PTR)&reg[0]; 
   
   pspace = (LONG_PTR)(malloc(maxpspace*sizeof(LONG)));
   if (!pspace)
      quit("Not enough core!\n");
   max_fence = (CHAR_PTR)(pspace + maxpspace);

   memory = (LONG_PTR)(malloc(maxmem*sizeof(LONG)));
   if (!memory)
      quit("Not enough core!\n");

   tstack = (LONG_PTR)(malloc(maxtrail*sizeof(LONG)));
   if (!tstack)
      quit("Not enough core!\n");

   allocateTableArea();
   /*   allocateSubgoalTable(); */

   gc_low = (LONG_PTR)(malloc(500000*sizeof(LONG)));
   gc_upper = gc_low+500000-1;

   heap_bottom  = memory;
   local_bottom = memory + maxmem;
   trail_bottom = tstack + maxtrail;
   tstack = tstack + 500;

   hreg  = heap_bottom;
   treg  = trail_bottom - 1;

   curr_fence     = (CHAR_PTR)pspace;

   *(LONG_PTR)curr_fence = fail;  curr_fence += sizeof(LONG);

   addr_halt = (LONG_PTR)curr_fence;
   *(LONG_PTR)curr_fence = halt;    
   curr_fence += sizeof(LONG);

   addr_halt0 = (LONG_PTR)curr_fence;
   *(LONG_PTR)curr_fence = halt0;    
   curr_fence += sizeof(LONG);
  

   sfreg = local_bottom;
   *sfreg = (LONG)sfreg;
   local_top = sfreg;
   *(local_top-1) = (LONG)addr_halt;
   *(local_top-2) = (LONG)(local_top - 7);
   *(local_top-3) = ADDTAG((LONG)(local_top + 1),AR_IS_SUSP);
   *(local_top-4) = (LONG)NULL;    /* reent */
   *(local_top-5) = (LONG)sfreg;    /* prev */
   *(local_top-6) = (LONG)hreg; FOLLOW(hreg++) = SUSP_SLEEP;   /* status */
   local_top -= 7;

   local_top--;    /* for holding term in call_bprolog_term(term) */

   breg  = local_top;
   arreg = breg;
   local_top = arreg-9;
   AR_AR(arreg) = (LONG)arreg;
   AR_CPS(arreg) = (LONG)addr_halt;    /* CPS : return 1 on final success */
   AR_TOP(arreg) = (LONG)local_top;  /* TOP */
   AR_BTM(arreg) = ADDTAG((LONG)arreg,AR_IS_NONDET); /* BTM */
   AR_B(arreg) = (LONG)breg;          /* B    */
   AR_CPF(arreg)  = (LONG)addr_halt0;   /* CPF : return 0 on final failure */
   AR_H(arreg) = (LONG)hreg;          /* H    */
   AR_T(arreg) = (LONG)treg;          /* T    */
   AR_SF(arreg) = (LONG)sfreg;          /* T    */
   hbreg = hreg;

   *local_top = (LONG)arreg;
   arreg = local_top;
   *(arreg-1) = (LONG)addr_halt;
   *(arreg-2) = (LONG)local_top - 3;

   *(LONG_PTR)curr_fence = rest_indomain; 
   addr_rest_indomain = (LONG_PTR)curr_fence; curr_fence += sizeof(LONG);

   *(LONG_PTR)curr_fence = (LONG)(curr_fence + 3*sizeof(LONG));
   curr_fence += sizeof(LONG);

   *(LONG_PTR)curr_fence = (LONG)(curr_fence + 2*sizeof(LONG));
   curr_fence += sizeof(LONG);

   init_sym();
   
   c_INITIALIZE_TABLE();
   
   toam0.hreg = hreg;
   toam0.hbreg = hbreg;
   toam0.treg = treg;
   toam0.arreg = arreg;
   toam0.local_top = local_top;
   toam0.breg = breg;
   toam0.sfreg = sfreg;
   toam0.tareg = tareg;
   toam0.entry = 0;

   inst_begin = 0;
}  /* end of init_sym */

/*****************************************************************************/

init_loading(argc, argv)
int  argc;
char *argv[];
{
   CHAR c;
   WORD i;
   WORD n = 0;  /* number of the initial loaded files */

   for (i = 1; i < argc; i++) {
     if (*argv[i] == '-') {
       c = *(argv[i] + 1);
       switch (c) {
       case 'm':
       case 's':
       case 'p':
       case 'b': i++;
	 break;
       default: 
	 add_main_arg(argv[i]);
       }
     } else if (is_bc_file(argv[i])){
       int loaded_ok = loader(argv[i],1);
       if (loaded_ok==10) {
	 char errormsg[128];
	 sprintf(errormsg, "File '%s' cannot be opened\n",argv[i]);
	 quit(errormsg);
       } else if (loaded_ok)
	 quit("Error in loading initial files\n");
       n++;
     } else add_main_arg(argv[i]);
   }
   if (n == 0) {
     char name[256];
     char *s;

     s = getenv("BPDIR");
     if (s==NULL){printf("the environment variable BPDIR is not set\n");exit(0);};
     strcpy(name,s);
     strcat(name,"/bp.out");
     if (is_bc_file(name) && loader(name) != 10);
     else {
       char errormsg[128];
       sprintf(errormsg, "File '%s' cannot be opened. Set BPDIR correctly\n",name);
       quit(errormsg);
     }
   }
 }

int is_bc_file(main_arg)
CHAR_PTR main_arg;
{
  FILE *fp;
  BYTE magic;
  
  if (access(main_arg,0)==0){
#ifdef MSDOS
    fp = fopen(main_arg, "rb");
#else
    fp = fopen(main_arg, "r");
#endif
    if (fp == NULL)
      return 0;
    
    fread(&magic, 1, 1, fp);
    if (magic!=17){fclose(fp); return 0;}
     
    fread(&magic, 1, 1, fp);
    if (magic!=18){fclose(fp); return 0;}

    fread(&magic, 1, 1, fp);
    if (magic!=19){fclose(fp); return 0;}

    fread(&magic, 1, 1, fp);
    if (magic!=3){fclose(fp); return 0;}

    fclose(fp);
    return 1;
  }
  return 0;
}
     
add_main_arg(main_arg)
CHAR_PTR main_arg;
{
  LONG tmp;
  LONG parg;

  parg = build_ATOM(main_arg);
  tmp = main_args;
  main_args = build_LIST();
  build_ARG(parg);
  build_ARG(tmp);
}
    






