/* inst.h */

/* Instruction operand types  */
/* W --- Word (integers in program & variables & registers)    */
/* C --- Atom                                                  */
/* I --- Integer                                               */
/* S --- Structure                                             */
/* A --- Address                                               */

#define A 0
#define AAA 1
#define C 2
#define CA 3
#define E 4
#define I 5
#define IA 6
#define III 7
#define M 8
#define MC 9
#define N 10
#define NA 11
#define NAA 12
#define NAZ 13
#define NAZZ 14
#define NAZZZ 15
#define NAZZZZ 16
#define NN 17
#define NS 18
#define NZZ 19
#define R 20
#define RC 21
#define S 22
#define SA 23
#define XA 24
#define XAA 25
#define XAAA 26
#define XCAA 27
#define XI 28
#define XIAA 29
#define XNA 30
#define XNAA 31
#define XS 32
#define XSAA 33
#define XX 34
#define XXX 35
#define XXY 36
#define XY 37
#define XYA 38
#define XYX 39
#define XYY 40
#define YA 41
#define YAA 42
#define YAAA 43
#define YCA 44
#define YCAA 45
#define YI 46
#define YIA 47
#define YIAA 48
#define YNA 49
#define YNAA 50
#define YS 51
#define YSA 52
#define YSAA 53
#define YX 54
#define YXX 55
#define YXY 56
#define YY 57
#define YYA 58
#define YYX 59
#define YYY 60
#define YYYY 61
#define YYYYYY 62
#define Z 63
#define ZZ 64
#define ZZA 65
#define ZZZ 66
#define AA 67
#define NAAAS 68
#define YAAS 69
#define AAS 70
#define NNA 71
#define Z4 72
#define Z5 73
#define AASA 74
#define NNSA  75
#define Z6 76

struct opcode_info {
   char  *name;
   int    num;
   int    type;
   int    size;
};

extern  struct opcode_info  xxopcode[];

#define noop 0
#define jmp 1
#define djmp 2
#define jmpn_eq_struct_x 3
#define jmpn_eq_struct_y 4
#define jmpn_eq_atom_x 5
#define jmpn_eq_atom_y 6
#define jmpn_nil_x 7
#define jmpn_nil_y 8
#define switch_list_x 9
#define switch_list_y 10
#define switch_list_yxx 11
#define switch_list_yxy 12
#define switch_list_yyx 13
#define switch_list_yyy 14
#define jmpn_eq_int_x 15
#define jmpn_eq_int_y 16
#define jmpn_eql 17
#define jmp_eql 18
#define jmp_eql_yy 19
#define jmpn_gt 20
#define jmpn_gt_yy 21
#define jmpn_ge 22
#define jmpn_ge_yy 23
#define jmpn_id 24
#define jmp_id 25
#define jmpn_var_x 26
#define jmpn_var_y 27
#define jmp_var_x 28
#define jmp_var_y 29
#define jmpn_atom_x 30
#define jmpn_atom_y 31
#define jmpn_atomic_x 32
#define jmpn_atomic_y 33
#define jmpn_num_x 34
#define jmpn_num_y 35
#define jmpn_float_x 36
#define jmpn_float_y 37
#define jmpn_int_x 38
#define jmpn_int_y 39
#define hash_jmpn_nil 40
#define hash_jmpn_list 41
#define hash_jmpn_int 42
#define hash_jmpn_atom 43
#define hash_jmpn_struct 44
#define hash_jmpn_struct_x 45
#define hash_jmpn_struct_y 46
#define hash_jmpn_struct_xx 47
#define hash_jmpn_struct_xy 48
#define hash_jmpn_struct_yx 49
#define hash_jmpn_struct_yy 50
#define unify_struct_x 51
#define unify_struct_y 52
#define unify_list_x 53
#define unify_list_y 54
#define unify_nil_x 55
#define unify_nil_y 56
#define unify_atom_x 57
#define unify_int_x 58
#define unify_atom_y 59
#define unify_int_y 60
#define unify_ux_ux 61
#define unify_ux_uy 62
#define unify_uy_uy 63
#define unify_cons_x 64
#define unify_cons_y 65
#define fork_unify_struct_y 66
#define fork_unify_list_y 67
#define fork_unify_nil_y 68
#define fork_unify_atom_y 69
#define fork_unify_int_y 70
#define fork_unify_uy_uy 71
#define fork_unicut_struct_y 72
#define fork_unicut_list_y 73
#define fork_unicut_nil_y 74
#define fork_unicut_atom_y 75
#define fork_unicut_int_y 76
#define fork_unicut_uy_uy 77
#define unify0_struct_y 78
#define unify0_list_y 79
#define unify0_nil_y 80
#define unify0_atom_y 81
#define unify0_int_y 82
#define unify0_uy_uy 83
#define unicut_struct_y 84
#define unicut_list_y 85
#define unicut_nil_y 86
#define unicut_atom_y 87
#define unicut_int_y 88
#define unicut_uy_uy 89
#define unicut 90
#define unify_arg_nil 91
#define unify_arg_atom 92
#define unify_arg_int 93
#define unify_arg_ux_ux 94
#define unify_arg_ux 95
#define unify_arg_ux_vx 96
#define unify_arg_ux_vy 97
#define unify_arg_uy_uy 98
#define unify_arg_uy 99
#define unify_arg_wy 100
#define unify_arg_vx_vx 101
#define unify_arg_vx 102
#define unify_arg_vy_vy 103
#define unify_arg_vy 104
#define unify_arg_list 105
#define unify_arg_struct 106
#define unify_arg_void_one 107
#define unify_arg_void 108
#define unify_arg_vx_vy 109
#define unify_arg_vx_ux 110
#define unify_arg_vx_uy 111
#define unify_arg_vy_vx 112
#define unify_arg_vy_ux 113
#define unify_arg_vy_uy 114
#define unify_arg_iii 115
#define move_struct_x 116
#define move_struct_y 117
#define move_list_x 118
#define move_list_y 119
#define move_nil_x 120
#define move_nil_y 121
#define move_atom_x 122
#define move_int_x 123
#define move_atom_y 124
#define move_int_y 125
#define move_x_ux 126
#define move_x_uy 127
#define move_y_ux 128
#define move_yy_yy_yy 129
#define move_yy_yy 130
#define move_y_uy 131
#define move_vx 132
#define move_vy 133
#define move_x_wy 134
#define move_yy_yw 135
#define move_y_wy 136
#define move_yw_yy 137
#define and 138
#define or 139
#define lshiftl 140
#define lshiftr 141
#define complement 142
#define add_xxx 143
#define add_xyx 144
#define add_yyx 145
#define add 146
#define add1_y 147
#define sub_xxx 148
#define sub_xyx 149
#define sub_yxx 150
#define sub_yyx 151
#define sub 152
#define sub1_y 153
#define mul 154
#define div_ 155
#define idiv 156
#define divge 157
#define divle 158
#define mod 159
#define para_struct 160
#define para_list 161
#define para_nil 162
#define para_atom 163
#define para_int 164
#define para_ux_ux_ux 165
#define para_ux_ux 166
#define para_ux 167
#define para_uy_uy_uy_uy 168
#define para_uy_uy_uy 169
#define para_uy_uy 170
#define para_uy 171
#define para_vx 172
#define para_vy_vy 173
#define para_vy 174
#define para_void_one 175
#define para_void 176
#define para_vy_ux 177
#define para_vy_uy 178
#define para_ux_vy 179
#define para_ux_ux_uy 180
#define para_ux_uy 181
#define para_ux_uy_uy 182
#define para_uy_vy 183
#define para_ux_uy_ux 184
#define para_uy_ux 185
#define para_uy_ux_ux 186
#define para_uy_ux_uy 187
#define para_uy_uy_ux 188
#define call 189
#define call_d 190
#define callv 191
#define execute 192
#define executev 193
#define return_a 194
#define return_b 195
#define return_d 196
#define jmpn_det 197
#define save_ht_jmp 198
#define allocate_flat 199
#define allocate_flat_b 200
#define allocate_nondet 201
#define fail 202
#define fail0 203
#define fork 204
#define commit 205
#define cut 206
#define cut_fail 207
#define cut_return 208
#define save_b 209
#define getbreg 210
#define putbreg 211
#define getpbreg 212
#define hash_x 213
#define hash_y 214
#define arg 215
#define arg0 216
#define setarg 217
#define setarg0 218
#define functor 219
#define func_arity 220
#define get_ar_cps 221
#define put_ar_cps 222
#define move_ar_cps 223
#define jmpn_det_get_ar_cps 224
#define builtin0 225
#define builtin1 226
#define builtin2 227
#define builtin3 228
#define builtin4 229
#define allocate_susp 230
#define trigger_var_ins 231
#define trigger_var_min 232
#define trigger_var_max 233
#define trigger_var_dom 234
#define delay 235
#define end_delay 236
#define nondet 237
#define jmpn_dvar_y 238
#define jmpn_susp_var_y 239
#define jmp_susp 240
#define domain_set_false_yx 241
#define domain_set_false_yy 242
#define domain_set_false 243
#define no_vars_gt 244
#define domain_min_max 245
#define domain_min 246
#define domain_max 247
#define domain_min_max_u 248
#define domain_min_u 249
#define domain_max_u 250
#define domain_region 251
#define domain_region_min 252
#define domain_region_max 253
#define first_indomain 254
#define rest_indomain 255
#define halt 256
#define endfile 257
#define tabsize 258
#define halt0 259
#define table_allocate 260
#define table_add_use_answer 261
#define table_use_answer_fork 262
#define table_check_completion 263
#define table_cut 264
#define table_end 265
#define interval_consistent_eq 266
#define interval_consistent_ge 267
#define nary_to_binary 268
#define trigger_ins_min_max 269
#define interval_consistent_eq_nocoe 270

