#include "inst.h"

struct opcode_info xxopcode[] = {
{ "noop",                  noop,              E,    1},
{ "jmp",                   jmp,               A,    2},
{ "djmp",                  djmp,              A,    2},
{ "jmpn_eq_struct_x",      jmpn_eq_struct_x,  XSAA, 5},
{ "jmpn_eq_struct_y",      jmpn_eq_struct_y,  YSAA, 5},
{ "jmpn_eq_atom_x",        jmpn_eq_atom_x,    XCAA, 5},
{ "jmpn_eq_atom_y",        jmpn_eq_atom_y,    YCAA, 5},
{ "jmpn_nil_x",            jmpn_nil_x,        XAA,  4},
{ "jmpn_nil_y",            jmpn_nil_y,        YAA,  4},
{ "switch_list_x",         switch_list_x,     XAAA, 5},
{ "switch_list_y",         switch_list_y,     YAAA, 5},
{ "switch_list_yxx",       switch_list_yxx,  YAAA,  5},
{ "switch_list_yxy",       switch_list_yxy,  YAAA,  5},
{ "switch_list_yyx",       switch_list_yyx,  YAAA,  5},
{ "switch_list_yyy",       switch_list_yyy,  YAAA,  5},
{ "jmpn_eq_int_x",         jmpn_eq_int_x,    XIAA,  5},
{ "jmpn_eq_int_y",         jmpn_eq_int_y,    YIAA,  5},
{ "jmpn_eql",              jmpn_eql,          ZZA,  4},
{ "jmp_eql",               jmp_eql,           ZZA,  4},
{ "jmp_eql_yy",            jmp_eql_yy,        YYA,  4},
{ "jmpn_gt",               jmpn_gt,           ZZA,  4},
{ "jmpn_gt_yy",            jmpn_gt_yy,        YYA,  4},
{ "jmpn_ge",               jmpn_ge,           ZZA,  4},
{ "jmpn_ge_yy",            jmpn_ge_yy,        YYA,  4},
{ "jmpn_id",               jmpn_id,           ZZA,  4},
{ "jmp_id",                jmp_id,            ZZA,  4},
{ "jmpn_var_x",            jmpn_var_x,        XA,   3},
{ "jmpn_var_y",            jmpn_var_y,        YA,   3},
{ "jmp_var_x",             jmp_var_x,         XA,   3},
{ "jmp_var_y",             jmp_var_y,         YA,   3},
{ "jmpn_atom_x",           jmpn_atom_x,       XA,   3},
{ "jmpn_atom_y",           jmpn_atom_y,       YA,   3},
{ "jmpn_atomic_x",         jmpn_atomic_x,     XA,   3},
{ "jmpn_atomic_y",         jmpn_atomic_y,     YA,   3},
{ "jmpn_num_x",            jmpn_num_x,        XA,   3},
{ "jmpn_num_y",            jmpn_num_y,        YA,   3},
{ "jmpn_float_x",          jmpn_float_x,      XA,   3},
{ "jmpn_float_y",          jmpn_float_y,      YA,   3},
{ "jmpn_int_x",            jmpn_int_x,        XA,   3},
{ "jmpn_int_y",            jmpn_int_y,        YA,   3},
{ "hash_jmpn_nil",         hash_jmpn_nil,     A,    2},
{ "hash_jmpn_list",        hash_jmpn_list,    A,    2},
{ "hash_jmpn_int",         hash_jmpn_int,     IA,   3},
{ "hash_jmpn_atom",        hash_jmpn_atom,    CA,   3},
{ "hash_jmpn_struct",      hash_jmpn_struct,  SA,   3},
{ "hash_jmpn_struct_x",    hash_jmpn_struct_x,SA,   3},
{ "hash_jmpn_struct_y",    hash_jmpn_struct_y,SA,   3},
{ "hash_jmpn_struct_xx",   hash_jmpn_struct_xx, SA,  3},
{ "hash_jmpn_struct_xy",   hash_jmpn_struct_xy, SA,  3},
{ "hash_jmpn_struct_yx",   hash_jmpn_struct_yx, SA,  3},
{ "hash_jmpn_struct_yy",   hash_jmpn_struct_yy, SA,  3},
{ "unify_struct_x",        unify_struct_x,    XS,   3},
{ "unify_struct_y",        unify_struct_y,    YS,   3},
{ "unify_list_x",          unify_list_x,      R,    2},
{ "unify_list_y",          unify_list_y,      M,    2},
{ "unify_nil_x",           unify_nil_x,       R,    2},
{ "unify_nil_y",           unify_nil_y,       M,    2},
{ "unify_atom_x",          unify_atom_x,      RC,   3},
{ "unify_int_x",           unify_int_x,       XI,   3},
{ "unify_atom_y",          unify_atom_y,      MC,   3},
{ "unify_int_y",           unify_int_y,       YI,   3},
{ "unify_ux_ux",           unify_ux_ux,       XX,   3},
{ "unify_ux_uy",           unify_ux_uy,       XY,   3},
{ "unify_uy_uy",           unify_uy_uy,       YY,   3},
{ "unify_cons_x",          unify_cons_x,      YX,   3},
{ "unify_cons_y",          unify_cons_y,      YY,   3},
{ "fork_unify_struct_y",   fork_unify_struct_y,YSA, 4},
{ "fork_unify_list_y",     fork_unify_list_y,  YA,  3},
{ "fork_unify_nil_y",      fork_unify_nil_y,   YA,  3},
{ "fork_unify_atom_y",     fork_unify_atom_y,  YCA, 4},
{ "fork_unify_int_y",      fork_unify_int_y,   YIA, 4},
{ "fork_unify_uy_uy",      fork_unify_uy_uy,   YYA, 4},
{ "fork_unicut_struct_y",  fork_unicut_struct_y,YSA, 4},
{ "fork_unicut_list_y",    fork_unicut_list_y,  YA,  3},
{ "fork_unicut_nil_y",     fork_unicut_nil_y,   YA,  3},
{ "fork_unicut_atom_y",    fork_unicut_atom_y,  YCA, 4},
{ "fork_unicut_int_y",     fork_unicut_int_y,   YIA, 4},
{ "fork_unicut_uy_uy",     fork_unicut_uy_uy,   YYA, 4},
{ "unify0_struct_y",       unify0_struct_y,   YS,   3},
{ "unify0_list_y",         unify0_list_y,     M,    2},
{ "unify0_nil_y",          unify0_nil_y,      M,    2},
{ "unify0_atom_y",         unify0_atom_y,     MC,   3},
{ "unify0_int_y",          unify0_int_y,      YI,   3},
{ "unify0_uy_uy",          unify0_uy_uy,      YY,   3},
{ "unicut_struct_y",       unicut_struct_y,  YS,   3},
{ "unicut_list_y",         unicut_list_y,    M,    2},
{ "unicut_nil_y",          unicut_nil_y,     M,    2},
{ "unicut_atom_y",         unicut_atom_y,    MC,   3},
{ "unicut_int_y",          unicut_int_y,     YI,   3},
{ "unicut_uy_uy",          unicut_uy_uy,    YY,   3},
{ "unicut",                unicut,            E,    1},
{ "unify_arg_nil",         unify_arg_nil,     E,    1},
{ "unify_arg_atom",        unify_arg_atom,    C,    2},
{ "unify_arg_int",         unify_arg_int,     I,    2},
{ "unify_arg_ux_ux",       unify_arg_ux_ux,   XX,   3},
{ "unify_arg_ux",          unify_arg_ux,      R,    2},
{ "unify_arg_ux_vx",       unify_arg_ux_vx,   XX,   3},
{ "unify_arg_ux_vy",       unify_arg_ux_vy,   XY,   3},
{ "unify_arg_uy_uy",       unify_arg_uy_uy,   YY,   3},
{ "unify_arg_uy",          unify_arg_uy,      M,    2},
{ "unify_arg_wy",          unify_arg_wy,      M,    2},
{ "unify_arg_vx_vx",       unify_arg_vx_vx,   XX,   3},
{ "unify_arg_vx",          unify_arg_vx,      R,    2},
{ "unify_arg_vy_vy",       unify_arg_vy_vy,   YY,   3},
{ "unify_arg_vy",          unify_arg_vy,      M,    2},
{ "unify_arg_list",        unify_arg_list,    E,    1},
{ "unify_arg_struct",      unify_arg_struct,  S,    2},
{ "unify_arg_void_one",    unify_arg_void_one,E,    1},
{ "unify_arg_void",        unify_arg_void,    N,    2},
{ "unify_arg_vx_vy",       unify_arg_vx_vy,   XY,   3},
{ "unify_arg_vx_ux",       unify_arg_vx_ux,   XX,   3},
{ "unify_arg_vx_uy",       unify_arg_vx_uy,   XY,   3},
{ "unify_arg_vy_vx",       unify_arg_vy_vx,   YX,   3},
{ "unify_arg_vy_ux",       unify_arg_vy_ux,   YX,   3},
{ "unify_arg_vy_uy",       unify_arg_vy_uy,   YY,   3},
{ "unify_arg_iii",         unify_arg_iii,     III,  4},
{ "move_struct_x",         move_struct_x,     XS,   3},
{ "move_struct_y",         move_struct_y,     YS,   3},
{ "move_list_x",           move_list_x,       R,    2},
{ "move_list_y",           move_list_y,       M,    2},
{ "move_nil_x",            move_nil_x,        R,    2},
{ "move_nil_y",            move_nil_y,        M,    2},
{ "move_atom_x",           move_atom_x,       RC,   3},
{ "move_int_x",            move_int_x,        XI,   3},
{ "move_atom_y",           move_atom_y,       MC,   3},
{ "move_int_y",            move_int_y,        YI,   3},
{ "move_x_ux",             move_x_ux,         XX,   3},
{ "move_x_uy",             move_x_uy,         XY,   3},
{ "move_y_ux",             move_y_ux,         YX,   3},
{ "move_yy_yy_yy",         move_yy_yy_yy, YYYYYY,   7},
{ "move_yy_yy",            move_yy_yy,      YYYY,   5},
{ "move_y_uy",             move_y_uy,         YY,   3},
{ "move_vx",               move_vx,           R,    2},
{ "move_vy",               move_vy,           M,    2},
{ "move_x_wy",             move_x_wy,         XY,   3},
{ "move_yy_yw",            move_yy_yw,      YYYY,   5},
{ "move_y_wy",             move_y_wy,         YY,   3},
{ "move_yw_yy",            move_yw_yy,      YYYY,   5},
{ "and",                   and,               ZZZ,  4},
{ "or",                    or,                ZZZ,  4},
{ "lshiftl",               lshiftl,           ZZZ,  4},
{ "lshiftr",               lshiftr,           ZZZ,  4},
{ "complement",            complement,        ZZ,   3},
{ "add_xxx",               add_xxx,           XXX,  4},
{ "add_xyx",               add_xyx,           XYX,  4},
{ "add_yyx",               add_yyx,           YYX,  4},
{ "add",                   add,               ZZZ,  4},
{ "add1_y",                add1_y,            M,    2},
{ "sub_xxx",               sub_xxx,           XXX,  4},
{ "sub_xyx",               sub_xyx,           XYX,  4},
{ "sub_yxx",               sub_yxx,           YXX,  4},
{ "sub_yyx",               sub_yyx,           YYX,  4},
{ "sub",                   sub,               ZZZ,  4},
{ "sub1_y",                sub1_y,            M,    2},
{ "mul",                   mul,               ZZZ,  4},
{ "div_",                  div_,              ZZZ,  4},
{ "idiv",                  idiv,              ZZZ,  4},
{ "divge",                divge,              ZZZ,   4},
{ "divle",                divle,              ZZZ,   4},
{ "mod",                   mod,               ZZZ,  4},
{ "para_struct",           para_struct,       S,    2},
{ "para_list",             para_list,         E,    1},
{ "para_nil",              para_nil,          E,    1},
{ "para_atom",             para_atom,         C,    2},
{ "para_int",              para_int,          I,    2},
{ "para_ux_ux_ux",         para_ux_ux_ux,     XXX,  4},
{ "para_ux_ux",            para_ux_ux,        XX,   3},
{ "para_ux",               para_ux,           R,    2},
{ "para_uy_uy_uy_uy",      para_uy_uy_uy_uy,  YYYY, 5},
{ "para_uy_uy_uy",         para_uy_uy_uy,     YYY,  4},
{ "para_uy_uy",            para_uy_uy,        YY,   3},
{ "para_uy",               para_uy,           M,    2},
{ "para_vx",               para_vx,           R,    2},
{ "para_vy_vy",            para_vy_vy,        YY,   3},
{ "para_vy",               para_vy,           M,    2},
{ "para_void_one",         para_void_one,     E,    1},
{ "para_void",             para_void,         N,    2},
{ "para_vy_ux",            para_vy_ux,        YX,   3},
{ "para_vy_uy",            para_vy_uy,        YY,   3},
{ "para_ux_vy",            para_ux_vy,        XY,   3},
{ "para_ux_ux_uy",         para_ux_ux_uy,     XXY,  4},
{ "para_ux_uy",            para_ux_uy,        XY,   3},
{ "para_ux_uy_uy",         para_ux_uy_uy,     XYY,  4},
{ "para_uy_vy",            para_uy_vy,        YY,   3},
{ "para_ux_uy_ux",         para_ux_uy_ux,     XYX,  4},
{ "para_uy_ux",            para_uy_ux,        YX,   3},
{ "para_uy_ux_ux",         para_uy_ux_ux,     YXX,  4},
{ "para_uy_ux_uy",         para_uy_ux_uy,     YXY,  4},
{ "para_uy_uy_ux",         para_uy_uy_ux,     YYX,  4},
{ "call",                  call,              S,    2},
{ "call_d",                call_d,            A,    2},
{ "callv",                 callv,             Z,    2},
{ "execute",               execute,           S,    2},
{ "executev",              executev,          Z,    2},
{ "return_a",              return_a,          E,    1},
{ "return_b",              return_b,          E,    1},
{ "return_d",             return_d,           E,    1},
{ "jmpn_det",              jmpn_det,          A,    2},
{ "save_ht_jmp",           save_ht_jmp,      AA,    3},
{ "allocate_flat",         allocate_flat,     NN,   3},
{ "allocate_flat_b",       allocate_flat_b,   NN,   3},
{ "allocate_nondet",       allocate_nondet,   NN,   3},
{ "fail",                  fail,              E,    1},
{ "fail0",                 fail0,             E,    1},
{ "fork",                  fork,              A,    2},
{ "commit",                commit,            E,    1},
{ "cut",                   cut,               E,    1},
{ "cut_fail",              cut_fail,          E,    1},
{ "cut_return",            cut_return,        E,    1},
{ "save_b",                save_b,            E,    1},
{ "getbreg",               getbreg,           Z,    2},
{ "putbreg",               putbreg,           Z,    2},
{ "getpbreg",              getpbreg,          Z,    2},
{ "hash_x",                hash_x,            XNAA, 5},
{ "hash_y",                hash_y,            YNAA, 5},
{ "arg",                   arg,               ZZZ,  4},
{ "arg0",                  arg0,              NZZ,  4},
{ "setarg",                setarg,            ZZZ,  4},
{ "setarg0",               setarg0,           NZZ,  4},
{ "functor",               functor,           ZZZ,  4},
{ "func_arity",            func_arity,         ZZ,  3},
{ "get_ar_cps",            get_ar_cps,        E,    1},
{ "put_ar_cps",            put_ar_cps,        N,    2},
{ "move_ar_cps",           move_ar_cps,       N,    2},
{ "jmpn_det_get_ar_cps",   jmpn_det_get_ar_cps,A,   2},
{ "builtin0",             builtin0,           NA,   3},
{ "builtin1",             builtin1,           NAZ,   4},
{ "builtin2",             builtin2,           NAZZ,  5},
{ "builtin3",             builtin3,           NAZZZ, 6},
{ "builtin4",             builtin4,           NAZZZZ,7},
{ "allocate_susp",        allocate_susp,      NN,    3},
{ "trigger_var_ins",      trigger_var_ins,     Z,    2},
{ "trigger_var_min",      trigger_var_min,     Z,    2},
{ "trigger_var_max",      trigger_var_max,     Z,    2},
{ "trigger_var_dom",      trigger_var_dom,     Z,    2},
{ "delay",                delay,              AASA,  5},
{ "end_delay",            end_delay,          E,     1},
{ "nondet",               nondet,             N,     2},
{ "jmpn_dvar_y",          jmpn_dvar_y,        YA,    3},
{ "jmpn_susp_var_y",      jmpn_susp_var_y,    YA,    3},
{ "jmp_susp",             jmp_susp,            A,    2},
{ "domain_set_false_yx",  domain_set_false_yx,YX,    3},  
{ "domain_set_false_yy",  domain_set_false_yy,YY,    3},  
{ "domain_set_false",     domain_set_false,   ZZ,    3},  
{ "no_vars_gt",           no_vars_gt,         NNA,   4},
{ "domain_min_max",       domain_min_max,     ZZZ,   4},  
{ "domain_min",           domain_min,          ZZ,   3},  
{ "domain_max",           domain_max,          ZZ,   3},  
{ "domain_min_max_u",     domain_min_max_u,    Z4,   5},
{ "domain_min_u",         domain_min_u,       ZZZ,   4},
{ "domain_max_u",         domain_max_u,       ZZZ,   4},
{ "domain_region",        domain_region,      ZZZ,   4},  
{ "domain_region_min",    domain_region_min,   ZZ,   3},  
{ "domain_region_max",    domain_region_max,   ZZ,   3},  
{ "first_indomain",       first_indomain,     Z,     2},
{ "rest_indomain",        rest_indomain,      E,     1},
{ "halt",                  halt,              E,     1},
{ "endfile",               endfile,           A,     2},
{ "tabsize",               tabsize,           N,     2},
{ "halt0",                 halt0,                E,   1},
{ "table_allocate",        table_allocate,     NNSA,  5},
{ "table_add_use_answer",  table_add_use_answer,  N,  2},
{ "table_use_answer_fork",table_use_answer_fork,  NA, 3},
{ "table_check_completion",table_check_completion,A,  2},
{ "table_cut",             table_cut,             A,  2},
{ "table_end",             table_end,             A,  2},
{ "interval_consistent_eq",interval_consistent_eq,N,  2},
{ "interval_consistent_ge",interval_consistent_ge,N,  2},
{ "nary_to_binary",        nary_to_binary,       Z6,  7},
{ "trigger_ins_min_max",   trigger_ins_min_max,   N,  2},
{ "interval_consistent_eq_nocoe",interval_consistent_eq_nocoe,N,  2},
};

