#define CELL TERM

#define TRAIL_OVERFLOW \
       if (treg<tstack) { \
       quit("Trail stack overflow");}


#define VAL_TRAIL_TAGGED 0x1
#define VAL_TRAIL_NONTAGGED 0x3

#define IS_VAR_TRAIL(op) (TAG(op)==0x0)
#define IS_VAL_TRAIL_TAGGED(op) (TAG(op)==0x1)
#define IS_VAL_TRAIL_UNTAGGED(op) (TAG(op)==0x3)

#define PUSHTRAIL(val)   \
        if (((LONG)(val) > (LONG)breg) || ((LONG)(val) < (LONG)hbreg)) { \
        PUSHTRAILC(val,val);}

#define PUSHTRAIL_h(val)   \
        if ((LONG)(val) < (LONG)hbreg) { \
	PUSHTRAILC(val,val);}

#define PUSHTRAILB(p,cont) \
  if ((LONG)p<(LONG)hbreg) {\
       PUSHTRAILC(p,cont);}

#define PUSHTRAILC(addr,val) {\
        *treg-- = (LONG)(val); \
        *treg-- = (LONG)(addr); \
        TRAIL_OVERFLOW;}

#define POPTRAIL(t){LONG tmp_op; \
  ++t;tmp_op = FOLLOW(t); \
  ++t;*(LONG_PTR)tmp_op = FOLLOW(t); \
  }

#define UNDO_TRAILING \
  while (treg != treg0) { \
    POPTRAIL(treg); \
  }

#define IsNumberedVar(term) (((term) & TAG_MASK)==TAG_MASK)
#define NumberVar(num) (((LONG)(num) << 2) | TAG_MASK)

#define ARG(i,arity) *(arreg+arity-i+1)

#define NEW_VAR(op)                      \
  op = (LONG)hreg;                       \
  NEW_HEAP_FREE;

#define ASSIGN_STRUCT(op1,op2)           \
  *(LONG_PTR)(op1) = ADDTAG(hreg,STR);  \
  PUSHTRAIL(op1);                        \
  NEW_HEAP_NODE((LONG)op2);

#define ASSIGN_LIST(op)                  \
  *(LONG_PTR)(op) = ADDTAG(hreg,LST);   \
  PUSHTRAIL(op);

#define MOVE_STRUCT(op1,op2)             \
  op1 = ADDTAG(hreg,STR);               \
  NEW_HEAP_NODE((LONG)op2);

#define ASSIGN_VALUE(var,value)           \
  *(LONG_PTR)var = value;   \
  PUSHTRAIL(var)                 

#define ASSIGN_TRAIL_VALUE(var,value)           \
  *(LONG_PTR)var = value;   \
  PUSHTRAILC(var,var)

#define ASSIGN(var,value)                \
  *(LONG_PTR)var = value                 

#define ASSIGN_W_TEST(var,value)          \
  if (!ISVAR(var)){                       \
   printf("Wrong tuple pattern\n"); \
   return -1;                             \
  }                                       \
  *(LONG_PTR)var = value                 

#define LOCAL_OVERFLOW if (arreg-1000 < hreg) { \
  exception = control_stack_overflow;           \
  return -1;}

#define QUIT_IF_OVERFLOW_HEAP(margin) if (arreg-margin < hreg) quit("Control stack overflow\n")

#define BUILD_VALUE(op1,lab1) \
  SWITCH_OP(op1,lab1, \
	    {if (op1<(LONG)hreg) \
	       NEW_HEAP_NODE(op1); \
	    else { \
		FOLLOW(op1) = (LONG) hreg; \
		PUSHTRAIL(op1); \
		NEW_HEAP_FREE;}}, \
	    {NEW_HEAP_NODE(op1);}, \
	    {NEW_HEAP_NODE(op1);}, \
	    {NEW_HEAP_NODE(op1);}, \
	    {NEW_HEAP_NODE(UNTAGGED(op1));}) 

#define GET_CAR(op1,op2)                 \
  op1 = *((LONG_PTR)UNTAGGED(op2)); 
#define GET_CDR(op1,op2)                 \
  op1 = *((LONG_PTR)UNTAGGED(op2)+1);
#define GET_ARG(op1,op2,n)               \
  op1 = *((LONG_PTR)UNTAGGED(op2)+n);
#define FETCH_CAR(op)                    \
  *((LONG_PTR)UNTAGGED(op))
#define FETCH_CDR(op)                    \
  *((LONG_PTR)UNTAGGED(op)+1)

typedef  long int TERM;

#define CHECK_PCODE_1 \
    if (curr_fence + 100 >= max_fence){         \
       printf("code_area_overflow\n");    \
       exit(1);                         \
    }                                     

#define CHECK_PCODE_2 \
    if (next_fence + 100 >=max_fence){        \
       printf("code_area_overflow\n"); \
       exit(1);                      \
    } 

extern int is_ATOM();
extern int is_INTEGER();
extern int is_FLOAT();
extern int is_NIL();
extern int is_LIST();
extern int is_STRUCTURE();
extern int is_COMPOUND();
extern int get_INTEGER();
extern double get_FLOAT();
extern char *get_NAME();
extern int get_ARITY();
extern TERM get_ARG();
extern TERM build_VAR();
extern TERM build_INTEGER();
extern TERM build_FLOAT();
extern TERM build_ATOM();
extern TERM build_LIST();
extern TERM build_NIL();
extern TERM build_STRUCTURE();
extern void build_ARG();


