#include "macro.h"
#include "event.h"

#define MAX_NO_INST 50
int preInsts[MAX_NO_INST];

#define MARGIN 1250
#define P p_reg
#define B b_reg
#define HB hb_reg
#define AR ar_reg
#define LOCAL_TOP top_reg
#define T t_reg
#define H h_reg
#define SF sf_reg

#define PTR2 sreg

#define AR_IS_TOP AR_TOP(AR) == (LONG)LOCAL_TOP 

#define toam_CALL_UNIFY(op1,op2,lab){ \
	SAVE_HB_T; \
        if (!unify(op1,op2)){RESTORE_T; goto lab;} \
        else RESTORE_T; }
/*
#define ToamProfile 
*/
#ifdef ToamProfile
#define CASE(Inst) case Inst: execute_inst(Inst);update_space_counters(LOCAL_TOP,H,T);
#define CASE_OP(where,Type) case Type: incr_switch_type(where,Type);
#define profile_COUNT_REFERS(n) {int j; for (j=0;j<n;j++) distinguish_operand(*(P+j));}
#define INCR_REFER_Y(s,n) incr_refer_y(n)
#define UPDATE_SPACE_COUNTERS(l,h,t) update_space_counters(l,h,t)
#else
#define CASE(Inst) case Inst: 
#define CASE_OP(where,Type) case Type:
#define INCR_REFER_Y(s,n) 
#define profile_COUNT_REFERS(n)
#define UPDATE_SPACE_COUNTERS(l,h,t) 
#endif

#ifdef ToamProfile
#define PROFILE_INDEXICAL(type,c1,v1,c2,v2,c3,v3) profile_indexical(type,c1,v1,c2,v2,c3,v3)
#else
#define PROFILE_INDEXICAL(type,c1,v1,c2,v2,c3,v3) 
#endif

#define SAVE_REGS arreg = AR; breg = B; hbreg = HB; hreg = H; treg = T 
#define RESTORE_REGS  H = hreg; T = treg
#define SAVE_REGS_BUT_AR breg = B; hbreg = HB; hreg = H; treg = T 

#define SAVE_SF sfreg = SF
#define RESTORE_SF SF = sfreg

#define SAVE_H hreg = H
#define RESTORE_H H = hreg

#define SAVE_AR arreg = AR
#define RESTORE_AR AR = arreg

#define SAVE_H_T treg = T;hreg = H
#define SAVE_H_HB hreg = H; hbreg=HB
#define SAVE_H_HB_T treg = T;hreg = H; hbreg=HB
#define SAVE_AR_H_T arreg=AR;treg = T;hreg = H

#define RESTORE_H_T T = treg;H = hreg

#define SAVE_HB hbreg = HB

#define SAVE_HB_T treg = T; hbreg = HB

#define SAVE_T treg = T
#define RESTORE_T T = treg

#define GRA(i,arity) *(AR+arity-i+1)
#define CONTCASE_R     goto contcase_read
#define CONTCASE_W     goto contcase_write
#define BACKTRACK            goto backtrack
#define BACKTRACK0            goto backtrack0
#define CERROR(op1,op2)  printf("** %s: %s\n",op1,op2); \
  B = (LONG_PTR)UNTAGGED((LONG)GET_EP(interrupt_psc)); \
  goto backtrack;

#define OVERFLOW_C \
  if (AR <= H + MARGIN) { \
      printf("control stack overflow\n"); \
      if (toam0.entry==0) { \
        B = (LONG_PTR)UNTAGGED((LONG)GET_EP(interrupt_psc)); \
        HB = (LONG_PTR)AR_H(B); \
        goto backtrack;} \
      else exit(1);}

#define OPERAND_X      op1 = XC(*P++)
#define OPERAND_Y      op1 = YC(*P++)
#define OPERAND_S      op2 = *P++
#define OPERAND_C      op2 = *P++
#define OPERAND_W      op2 = *P++
#define OPERAND_XX     op1 = XC(*P++); op2 = XC(*P++);
#define OPERAND_XY     op1 = XC(*P++); op2 = YC(*P++);
#define OPERAND_YX     op1 = YC(*P++); op2 = XC(*P++);
#define OPERAND_YY     op1 = YC(*P++); op2 = YC(*P++);
#define OPERAND_XW     op1 = XC(*P++); op2 = *P++
#define OPERAND_YW     op1 = YC(*P++); op2 = *P++

#define XV  0
#define XV1 4
#define XU  1
#define XU1 5
#define YV  3
#define YU  7

/* if TAG = 010 or 110, then nothing is done */
#define OP_XY_CONT(op) \
   if (((op) & 0x7) == YU) op=YC((op)>>3); else op=XC((LONG)(op)&VAL_MASK1);
  
#define OP_CONT(op) \
    switch (op & 0x7) { \
	case XV: \
        case XV1: XC(op)=(LONG)H;op=(LONG)H;toam_NEW_HEAP_FREE;break; \
        case XU: \
        case XU1: op=XC(((LONG)(op) & VAL_MASK1)); break; \
        case YV: op=(LONG)Y(op>>3);FOLLOW(op)=op;break; \
        case YU: op=YC(op>>3);break; \
        default: break; \
	}

#define OP_Y_CONT(op) op = YC(op>>3)

#define OP_CONT_DEREF(op) \
    switch (op & 0x7) { \
	case XV: \
        case XV1: XC(op)=(LONG)H;op=(LONG)H;toam_NEW_HEAP_FREE;break; \
        case XU: \
        case XU1: op=XC(((LONG)(op) & VAL_MASK1)); DEREF(op);break; \
        case YV: op=(LONG)Y(op>>3);FOLLOW(op)=op;break; \
        case YU: op=YC(op>>3);DEREF(op);break; \
        default: break; \
	}

#define OP_ADDR(op) \
    switch (op & 0x7) { \
	case XV: \
        case XV1: op = (LONG)X(op);break; \
        case YV: op = (LONG)Y(op>>3);break; \
        default: printf("wrong operand type %d\n",op);exit(1); \
	}

#define OP_VALUE_DEREF(op) \
  if (!ISINT(op)){ \
     if (((op) & 0x7) == YU) \
       op=YC((op)>>3);  \
     else op=XC((LONG)(op)&VAL_MASK1); \
     DEREF_NONVAR(op); \
  }

#define OP_XY_ADDR(op) \
        if ((op & 0x4) == YV) \
           op=(LONG)Y(op>>3); 

#define OP_IS_INT(op) (op & 0x3)== ATM
#define OP_IS_XU(op) (op & 0x3)== XU
#define OP_IS_YU(op) (op & 0x7) == YU

#define ASSIGN_in_toam(op,value,TrailCode) \
  FOLLOW(op) = value; \
  TrailCode;

#define FAST_UNIFY(op,value) \
  switch (op & 0x7) { \
      case XV: \
      case XV1: XC(op) = value;break; \
      case XU: \
      case XU1: op=XC(((LONG)(op) & VAL_MASK1)); \
               DEREF(op); \
               if (ISVAR(op)){ \
                   FOLLOW(op) = value; \
                   toam_PUSHTRAIL_h(op); \
   	       } \
               else toam_CALL_UNIFY(op,value,backtrack); \
               break; \
      case YV: YC(op>>3) = value; break; \
      case YU: op=YC(op>>3);\
               DEREF(op); \
               if (ISVAR(op)){ \
                   FOLLOW(op) = value; \
                   toam_PUSHTRAIL(op); \
   	       } \
               else toam_CALL_UNIFY(op,value,backtrack); \
               break; \
      default: toam_CALL_UNIFY(op,value,backtrack); \
               break;}

#define OPERAND_BA0   
#define OPERAND_BA1   op1 = *P++; OP_CONT(op1)
#define OPERAND_BA2   OPERAND_BA1; op2 = *P++; OP_CONT(op2)
#define OPERAND_BA3   OPERAND_BA2; op3 = *P++; OP_CONT(op3) 
#define OPERAND_BA4   OPERAND_BA3; op4 = *P++; OP_CONT(op4)

#define XC(regno)   (*(LONG_PTR)(regno))
#define X(regno)    ((LONG)(regno))

#define YC(varno)   (*(AR + (varno)))
#define Y(varno)    (AR + (varno))

#define CPS op3

#define RAISE_EXCEPTION(e,g) \
      SAVE_REGS; \
      exception = e; \
      goal = g;\
      RESTORE_REGS; \
      goto catch_exception;   

#define toam_CHECK_INTEGER(op) \
  if (!ISINT(op)){ \
    RAISE_EXCEPTION(integer_expected,make_struct1("domain_var",op)); \
  }

#define toam_ENCODEFLOAT(op1,value) \
  SAVE_H; \
  FOLLOW(op1)=encodefloat(value); \
  RESTORE_H

#define toam_NEW_HEAP_FREE *H = (LONG)H; H++
#define toam_NEW_HEAP_NODE(x)  *H++ = x
#define toam_NEW_VAR(op) op = (LONG)H; \
  toam_NEW_HEAP_FREE;

#define toam_PUSHTRAIL(val) \
  if (((LONG)(val) > (LONG)B) || ((LONG)(val) < (LONG)HB)) \
       toam_PUSHTRAILC(val,val)

#define toam_PUSHTRAIL_h(val)\
        if ((LONG)(val) < (LONG)HB) \
           toam_PUSHTRAILC(val,val)

#define toam_PUSHTRAILB(addr,value) \
  if ((LONG)(addr)<(LONG)HB) \
           toam_PUSHTRAILC(addr,value)

#define toam_PUSHTRAILC(addr,value){ \
          *T-- = (LONG)(value); \
          *T-- = (LONG)(addr); \
          toam_TRAIL_OVERFLOW;}

#define toam_PUSHTRAIL_UC_0(addr) toam_PUSHTRAILC(addr,addr)

#define toam_TRAIL_OVERFLOW \
       if (T<tstack) { \
          printf("Trail stack overflow\n"); \
          B = (LONG_PTR)UNTAGGED((LONG)GET_EP(interrupt_psc)); \
          goto backtrack;}

#define FORK AR_CPF(AR) = *P++

#define  TABLE_CUT(end_b) \
    if (use_tabling){ \
        LONG_PTR gtable; \
        while (B<=end_b){ \
           gtable = (LONG_PTR)AR_TABLE(B); \
           if (gtable>tableArea && gtable<tableAreaBottom)GT_AR(gtable) = NULL;\
          B = (LONG_PTR)AR_B(B); \
        } \
    } 

#define TIDY_TRAIL { \
    sreg = (LONG_PTR)AR_T(B); \
    top = sreg; \
    while (top>T){ \
        tmp_op = *top--; \
        if (tmp_op>(LONG)B || tmp_op<(LONG)HB){ \
            if (IS_VAR_TRAIL(tmp_op)){ \
                *sreg-- = tmp_op; \
            } else { \
                *sreg-- = tmp_op; \
                *sreg-- = *top--; \
            } \
        } else { \
            if (!IS_VAR_TRAIL(tmp_op)){ \
                top--; \
            } \
        } \
    } \
    T = sreg; \
    if ((LONG_PTR)AR_T(B)<T) printf("<=STRANGE B=%x B(T)=%x T=%x\n",B,AR_T(B),T); \
 }


#define CUT \
    TABLE_CUT(AR); \
    B = (LONG_PTR)AR_B(AR); \
    HB = (LONG_PTR)AR_H(B); \
    LOCAL_TOP = (LONG_PTR)AR_TOP(AR); 


#define toam_BUILD_VALUE(op1,lab1) \
  SWITCH_OP_VAR(op1,lab1, \
	    {if (op1<(LONG)H) \
	       toam_NEW_HEAP_NODE(op1); \
	    else { \
		FOLLOW(op1) = (LONG) H; \
		toam_PUSHTRAIL(op1); \
		toam_NEW_HEAP_FREE;}}, \
            {toam_NEW_HEAP_NODE(UNTAGGED(op1));}, \
	    {toam_NEW_HEAP_NODE(op1);})

#define BUX \
  op1 = XC(*P++); \
  toam_NEW_HEAP_NODE(op1)

#define BWY \
  op1 = YC(*P++); \
  toam_NEW_HEAP_NODE(op1);

#define BUY(lab) \
  op1 = YC(*P++); \
  toam_BUILD_VALUE(op1,lab)

#define BVX \
  op1 = *P++; \
  XC(op1) = (LONG) H; \
  toam_NEW_HEAP_FREE

#define BVY \
  op1 = *P++; \
  YC(op1) = (LONG)H; \
  toam_NEW_HEAP_FREE

#define BL \
  H++; \
  *(H-1) = ADDTAG(H,LST) \
  
#define BS \
  op1 = *P++; \
  H++; \
  *(H-1) = ADDTAG(H,STR); \
  toam_NEW_HEAP_NODE(op1)

#define UNIFY_STRUCT_X(op1,op2,lab) \
  SWITCH_OP_STRUCT(op1,lab, \
		 {FOLLOW(op1) = ADDTAG(H,STR); \
  	          toam_PUSHTRAIL_h(op1); \
		  toam_NEW_HEAP_NODE(op2); \
		  goto contcase_write;}, \
		 {UNTAG(op1); \
  	          if (FOLLOW(op1) == op2) { \
		      sreg = (LONG_PTR) op1 + 1; \
		      goto contcase_read; \
		      }}, \
		 {goto bind_susp_var_str;}); \
    goto backtrack

#define UNIFY_STRUCT_Y(op1,op2,lab,VarCode,SucCode,Fail) \
  SWITCH_OP_STRUCT(op1,lab, \
		 {FOLLOW(op1) = ADDTAG(H,STR); \
		  VarCode; \
		  toam_NEW_HEAP_NODE(op2); \
		  goto contcase_write;}, \
		 {UNTAG(op1); \
                  if (FOLLOW(op1) == op2) { \
                      sreg = (LONG_PTR) op1 + 1; \
		      SucCode; \
		      goto contcase_read;}}, \
		 {SucCode; \
		  goto bind_susp_var_str;}); \
  Fail

#define UNIFY_LIST_X(op1,lab) \
  SWITCH_OP_LST(op1,lab, \
		{FOLLOW(op1) = ADDTAG(H,LST); \
		 toam_PUSHTRAIL_h(op1); \
		 goto contcase_write;}, \
		{sreg = (LONG_PTR) UNTAGGED(op1); \
		 goto contcase_read;}, \
		{goto bind_susp_var_list;}); \
  goto backtrack

#define UNIFY_LIST_Y(op1,lab,VarCode,SucCode,Fail) \
  SWITCH_OP_LST(op1,lab, \
		{FOLLOW(op1) = ADDTAG(H,LST); \
		 VarCode; \
		 goto contcase_write;}, \
		{sreg = (LONG_PTR) UNTAGGED(op1); \
		 SucCode; \
		 goto contcase_read;}, \
		{SucCode; \
		 goto bind_susp_var_list;}); \
  Fail

#define UNIFY_NIL_X(op1,lab) \
  SWITCH_OP_NIL(op1,lab, \
		{FOLLOW(op1) = nil_sym1; \
		 toam_PUSHTRAIL_h(op1); \
		 goto contcase_read;}, \
		{goto contcase_read;}, \
		{op2 = nil_sym1;goto bind_susp_var_value;}); \
  goto backtrack

#define UNIFY_NIL_Y(op1,lab,VarCode,SucCode,Fail) \
  SWITCH_OP_NIL(op1,lab, \
		{FOLLOW(op1) = nil_sym1; \
		 VarCode; \
		 goto contcase_read;}, \
		{SucCode; goto contcase_read;}, \
		{SucCode;op2 = nil_sym1; goto bind_susp_var_value;}); \
  Fail
  
#define UNIFY_INT_Y(op1,op2,lab,VarCode,SucCode,Fail) \
  SWITCH_OP_ATM(op1,lab, \
		{FOLLOW(op1) = op2; \
		 VarCode; \
		 goto contcase_read;}, \
		{if (op1 == op2){ SucCode; goto contcase_read;}}, \
		{SucCode; BIND_SUSP_VAR_VALUE(op1,op2);}); \
  Fail

#define UNIFY_ATOMIC12_X(op1,op2,lab,Fail) \
  SWITCH_OP_ATM(op1,lab, \
		{FOLLOW(op1) = op2; \
		 toam_PUSHTRAIL_h(op1); \
		 goto contcase_read;}, \
		{if (op1 == op2) goto contcase_read;}, \
		{goto bind_susp_var_value;}); \
  Fail

#define UNIFY_ATOMIC12_Y(op1,op2,lab,VarCode,SucCode,Fail) \
  SWITCH_OP_ATM(op1,lab, \
		{FOLLOW(op1) = op2; \
		 VarCode; \
		 goto contcase_read;}, \
		{if (op1 == op2){ SucCode; goto contcase_read;}}, \
		{SucCode; goto bind_susp_var_value;}); \
  Fail

#define UNIFY_ATOMIC21_X(op1,op2,lab,Fail) \
  SWITCH_OP_ATM(op1,lab, \
		{FOLLOW(op1) = op2; \
		 toam_PUSHTRAIL_h(op1); \
		 goto contcase_read;}, \
		{if (op1 == op2) goto contcase_read;}, \
		{goto bind_value_susp_var;}); \
  Fail

#define UNIFY_ATOMIC21_Y(op1,op2,lab,VarCode,SucCode,Fail) \
  SWITCH_OP_ATM(op1,lab, \
		{FOLLOW(op1) = op2; \
		 VarCode; \
		 goto contcase_read;}, \
		{if (op1 == op2){ SucCode; goto contcase_read;}}, \
		{SucCode; goto bind_value_susp_var;}); \
  Fail

#define MOVE_VALUE(op1,op2,lab) \
  SWITCH_OP_VAR(op2,lab, \
	    {if (op2>(LONG)H){ \
	       FOLLOW(op2) = (LONG)H; \
	       toam_PUSHTRAIL(op2);\
	       op1 = (LONG)H;\
	       toam_NEW_HEAP_FREE; \
	       } else op1 = op2;}, \
	    {op1 = UNTAGGED(op2);}, \
	    {op1 = op2;})

#define HASH_JMPN_STRUCT(ZZ1,ZZ2)\
    if (ISSTRUCT(op1) && (LONG)sym_ptr == op2) { \
	P += 2; \
	sreg = (LONG_PTR)tmp_op + 1; \
	ZZ1 = *sreg++;\
	ZZ2 = *sreg++;\
	goto contcase_read;\
    } \
    P = (LONG_PTR)*P; \
    goto contcase_read;                     

#define PS \
  *LOCAL_TOP-- = ADDTAG(H,STR); \
  toam_NEW_HEAP_NODE(*P++)

#define PL \
  *LOCAL_TOP-- = ADDTAG(H,LST)

#define PW \
  *LOCAL_TOP-- = *P++

#define PN \
  *LOCAL_TOP-- = nil_sym1

#define PUX \
   *LOCAL_TOP-- = XC(*P++)

#define PUY \
   *LOCAL_TOP-- = YC(*P++)

#define PVX \
  XC(*P++) = (LONG) H; \
  *LOCAL_TOP-- = (LONG) H; \
  toam_NEW_HEAP_FREE;

#define PVY \
  op1 = (LONG)Y(*P++); \
  FOLLOW(op1) = op1; \
  *LOCAL_TOP-- = op1

#define RVX \
  op1 = *P++; \
  XC(op1) = *sreg++
  
#define RVY \
  op1 = *P++; \
  YC(op1) = *sreg++

#define RI(lab) \
  op1 = *sreg++; \
  op2 = *P++; \
  lab:  if (ISNONVAR(op1)){if (op1 != op2) goto backtrack;} \
    else { \
        NDEREF(op1,lab); \
	FOLLOW(op1) = op2; \
	toam_PUSHTRAIL_h(op1);\
      }

#define RETURN_A \
  P = (LONG_PTR)AR_CPS(AR); \
  if (AR_IS_TOP) LOCAL_TOP = (LONG_PTR)UNTAGGED(AR_BTM(AR)); \
  AR = (LONG_PTR)AR_AR(AR); 

#define RETURN_B \
  P = (LONG_PTR)AR_CPS(AR); \
  AR = (LONG_PTR)AR_AR(AR); 

#define MOVE_STRUCT_X \
  XC(*P++) = ADDTAG(H,STR); \
  toam_NEW_HEAP_NODE(*P++)

#define MOVE_STRUCT_Y \
  YC(*P++) = ADDTAG(H,STR); \
  toam_NEW_HEAP_NODE(*P++)

#define MOVE_LIST_X \
  XC(*P++) = ADDTAG(H,LST)

#define MOVE_LIST_Y \
    YC(*P++) = ADDTAG(H,LST)

#define MOVE_NIL_X \
    XC(*P++) = nil_sym1

#define MOVE_NIL_Y \
    YC(*P++) = nil_sym1

#define MOVE_ATOMIC_X \
    op1 = *P++; \
    XC(op1) = *P++

#define MOVE_ATOMIC_Y \
    op1 = *P++; \
    YC(op1) = *P++

#define MOVE_X_UX \
    op1 = *P++; \
    XC(op1) = XC(*P++) \

#define MOVE_X_UY(lab) \
  op1 = *P++; \
  op2 = YC(*P++); \
  MOVE_VALUE(XC(op1),op2,lab)

#define MOVE_Y_UX \
  op1 = *P++; \
  YC(op1) = XC(*P++)

#define MOVE_Y_UY(lab) \
  op1 = *P++; \
  op2 = (LONG)YC(*P++); \
  MOVE_VALUE(YC(op1),op2,lab)
  
#define MOVE_VX \
  XC(*P++) = (LONG) H; \
  toam_NEW_HEAP_FREE


#define MOVE_VY \
  op1 = (LONG)Y(*P++); \
  FOLLOW(op1) = op1

#define MOVE_X_WY \
  op1 = *P++; \
  XC(op1) = YC(*P++) 

#define MOVE_Y_WY \
  op1 = *P++; \
  YC(op1) = YC(*P++) 
  
#define CALL_D \
  *LOCAL_TOP = (LONG)AR; \
  AR = LOCAL_TOP; \
  AR_CPS(AR) = (LONG)(P+1); \
  P = (LONG_PTR)*P

#define CALLV \
  if (ISSTRUCT(op2)){ \
    sym_ptr = GET_STR_SYM_REC(op2); \
    UNTAG(op2); \
    INCR_REFER_Y("callv",GET_ARITY(sym_ptr)); \
    for (i = 1; i <= GET_ARITY(sym_ptr); ++i) { \
      *LOCAL_TOP-- = FOLLOW((LONG_PTR)op2 + i); \
    } \
  } \
  else if (ISATOM(op2)) \
    sym_ptr = GET_ATM_SYM_REC(op2); \
  else if (ISLIST(op2)){ \
    sym_ptr = list_psc; \
    UNTAG(op2); \
    *LOCAL_TOP-- = FOLLOW((LONG_PTR)op2); \
    *LOCAL_TOP-- = FOLLOW((LONG_PTR)op2+1); \
  } \
  else { \
    RAISE_EXCEPTION(illegal_predicate,op2); \
  } 
    
#define SAVE_HT_JMP \
   if (trigger_no==0){ \
       AR_H(AR) = (LONG)H; \
       HB = H; \
       AR_T(AR) = (LONG)T; \
       B = AR; \
       P = (LONG_PTR)*P;} \
    else { \
       P = (LONG_PTR)*(P+1); \
       goto trigger_on_handler;}

#define JMPN_DET \
   if (AR_IS_TOP && AR<B) { \
      P++; \
      CONTCASE_R; \
    }  else { \
      P = (LONG_PTR)*P; \
      CONTCASE_R; \
    } 

#define UNIFY_CONS(lab1,lab2,BuildCode1,BuildCode2,UnifyArgCode) \
  SWITCH_OP_CONS(op1,lab1, \
	       {FOLLOW(op1) = ADDTAG(H,LST); \
		toam_PUSHTRAIL(op1); \
		BuildCode1; \
		YC(tmp_op) = (LONG)H; \
		toam_NEW_HEAP_FREE; \
		CONTCASE_W;}, \
	       {UNTAG(op1); \
		YC(tmp_op) = *((LONG_PTR)op1+1); \
		op1 = *(LONG_PTR)op1; \
		SWITCH_OP(op1,lab2, \
			  {goto unify_nsv_d;}, \
			  {UnifyArgCode;}, \
			  {goto unify_lst_d;}, \
			  {goto unify_str_d;}, \
			  {goto unify_susp_d;});}, \
	       {BIND_SUSP_VAR_CONS(op1,BuildCode2);}); \
  BACKTRACK

#define BIND_SUSP_VAR_STR(op1,op2){ \
  top = (LONG_PTR)(op1 & VAL_MASK); \
  if (!IS_UN_DOMAIN(top)){ \
     BACKTRACK; \
  } \
  toam_PUSHTRAILB(top,op1); \
  FOLLOW(top) = ADDTAG(H,STR); \
  *H++ = op2; \
  INSERT_TRIGGER_var_ins(top);\
  CONTCASE_W;}

#define BIND_SUSP_VAR_LIST(op1){ \
  top = (LONG_PTR)(op1 & VAL_MASK); \
  if (!IS_UN_DOMAIN(top)){ \
     BACKTRACK; \
  } \
  toam_PUSHTRAILB(top,op1); \
  FOLLOW(top) = ADDTAG(H,LST); \
  INSERT_TRIGGER_var_ins(top); \
  CONTCASE_W;}

#define BIND_SUSP_VAR_VALUE(op1,op2) {\
  top = (LONG_PTR)(op1 & VAL_MASK); \
  if (!IS_UN_DOMAIN(top)){ \
    if (!ISINT(op2)) BACKTRACK; \
    op3 = INTVAL(op2); \
    if (op3 < DV_first(top) || op3 > DV_last(top)) BACKTRACK; \
    if (IS_IT_DOMAIN(top)) ; \
    else if (!domain_true_bv(top,op3)) BACKTRACK; \
    INSERT_TRIGGER_dvar_ins(top); \
  } else { \
    INSERT_TRIGGER_var_ins(top);} \
  toam_PUSHTRAILB(top,op1); \
  FOLLOW(top) = op2; \
  CONTCASE_R;}


#define BIND_DVAR_VALUE(op1,op2) {\
  toam_PUSHTRAILB(op1,FOLLOW(op1)); \
  FOLLOW(op1) = op2; \
  INSERT_TRIGGER_dvar_ins(op1); }

#define BIND_SUSP_VAR_CONS(op1,BuildCode){\
  top = (LONG_PTR)(op1 & VAL_MASK); \
  if (!IS_UN_DOMAIN(top)){ \
     BACKTRACK; \
  } \
  toam_PUSHTRAILB(top,op1); \
  INSERT_TRIGGER_var_ins(top); \
  FOLLOW(top) = ADDTAG(H,LST); \
  BuildCode; \
  YC(tmp_op) = (LONG)H; \
  toam_NEW_HEAP_FREE; \
  CONTCASE_W;}

#define CATCH_WAKE_EVENT if (toam_signal_vec!=0){ \
       if (trigger_no != 0){goto trigger_on_handler;} else goto interrupt_handler;}

#define  CREATE_SUSP_VAR(op1){ \
   FOLLOW(op1) = (LONG)H; \
   toam_PUSHTRAIL(op1); \
   dv_ptr = H; \
   DV_var(dv_ptr) =  ((LONG)H | SUSP); \
   DV_type(dv_ptr) = UN_DOMAIN; \
   H += SIZE_OF_DV; \
  }

#define  CREATE_SUSP_VAR_ins(op1){ \
   CREATE_SUSP_VAR(op1); \
   DV_min_cs(dv_ptr) = nil_sym; \
   DV_max_cs(dv_ptr) = nil_sym; \
   DV_dom_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_ins_cs(dv_ptr),H,AR);}

#define  CREATE_SUSP_VAR_min(op1){ \
   CREATE_SUSP_VAR(op1); \
   DV_max_cs(dv_ptr) = nil_sym; \
   DV_dom_cs(dv_ptr) = nil_sym; \
   DV_ins_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_min_cs(dv_ptr),H,AR);}

#define  CREATE_SUSP_VAR_max(op1){ \
   CREATE_SUSP_VAR(op1); \
   DV_dom_cs(dv_ptr) = nil_sym; \
   DV_ins_cs(dv_ptr) = nil_sym; \
   DV_min_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_max_cs(dv_ptr),H,AR);}

#define  CREATE_SUSP_VAR_dom(op1){ \
   CREATE_SUSP_VAR(op1); \
   DV_ins_cs(dv_ptr) = nil_sym; \
   DV_min_cs(dv_ptr) = nil_sym; \
   DV_max_cs(dv_ptr) = nil_sym; \
   INITIALIZE_DV_CS(DV_dom_cs(dv_ptr),H,AR);}

#define INSERT_SUSP_CALL_ins(op){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_ins_cs(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

#define INSERT_SUSP_CALL_min(op){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_min_cs(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

#define INSERT_SUSP_CALL_max(op){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_max_cs(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

#define INSERT_SUSP_CALL_dom(op){ \
   dv_ptr = (LONG_PTR)UNTAGGED(op); \
   top = A_DV_dom_cs(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   INSERT_SUSP_CALL_DV_CS(top,H,AR); \
   }

#define CONNECT_SUSP_FRAME { \
   AR_PREV(AR) = (LONG)SF; \
   SF = AR; \
   }

#define RESET_AR_REEP(address){ \
   top = (LONG_PTR)AR_REEP_ADDR(AR); \
   if (AR>B) toam_PUSHTRAILC(top,FOLLOW(top)); \
   FOLLOW(top) = (LONG)address; \
   }				 

#define DISCONNECT_SUSP_FRAME { \
   status_ptr = (LONG_PTR)AR_STATUS(AR); \
   FOLLOW(status_ptr) = SUSP_EXIT; \
   if (SF>B) { \
       toam_PUSHTRAILC(status_ptr,SUSP_SLEEP); \
   }; \
   if (SF == AR) { \
        do { \
           SF = (LONG_PTR)AR_PREV(SF); \
        } while (FRAME_IS_DEAD(SF) && SF<B);  \
   } \
}

#define CONNECT_WOKEN_FRAME(frame) { \
   FOLLOW(frame) = (LONG)AR; \
   FOLLOW(frame-1) = (LONG)P; \
   AR = frame;}

#define CONNECT_WOKEN_FRAME_min_max(constr){ \
   top = (LONG_PTR)UNTAGGED(CS_STATUS(constr)); \
   op1 = UNTAGGED(CS_FRAME(constr)); \
   if (op1 > (LONG)B) toam_PUSHTRAILC(top,SUSP_SLEEP); \
   if (FOLLOW(top)==SUSP_SLEEP) { \
        FOLLOW(top) = SUSP_RUN; \
        top = (LONG_PTR)op1; \
        CONNECT_WOKEN_FRAME(top); \
        P = (LONG_PTR)FOLLOW(AR_REEP(AR)+sizeof(LONG)); \
   } else { \
        FOLLOW(top) = SUSP_REENT; \
   } \
}

#define CONNECT_WOKEN_FRAME_ins(constr){ \
   top = (LONG_PTR)UNTAGGED(CS_STATUS(constr)); \
   op1 = UNTAGGED(CS_FRAME(constr)); \
   if ( op1 > (LONG)B) toam_PUSHTRAILC(top,SUSP_SLEEP); \
   if (FOLLOW(top)==SUSP_SLEEP) { \
        FOLLOW(top) = SUSP_RUN; \
        top = (LONG_PTR)op1; \
        CONNECT_WOKEN_FRAME(top); \
        P = (LONG_PTR)FOLLOW(AR_REEP(AR)); \
   } else { \
        FOLLOW(top) = SUSP_REENT; \
   } \
}

#define toam_UPDATE_FIRST(dv_ptr,first){ \
   top = A_DV_first(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = first; \
   INSERT_TRIGGER_min(dv_ptr); } \

#define toam_UPDATE_LAST(dv_ptr,last){ \
   top = A_DV_last(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = last; \
   INSERT_TRIGGER_max(dv_ptr); } \

#define toam_UPDATE_SIZE(dv_ptr,size){ \
   top = A_DV_size(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = size;} \

#define toam_UPDATE_TYPE(dv_ptr,type){ \
   top = A_DV_type(dv_ptr); \
   toam_PUSHTRAILB(top,FOLLOW(top)); \
   FOLLOW(top) = type;} \

#define GET_DV_MIN(op) \
   if (IS_SUSP_VAR(op)){ \
      dv_ptr = (LONG_PTR)UNTAGGED(op); \
      op = DV_first(dv_ptr); \
   } else if (ISINT(op)) { \
      op = INTVAL(op); \
   } else { \
      dv_ptr = (LONG_PTR)UNTAGGED(op); \
      op = FOLLOW(dv_ptr); \
   }

#define GET_DV_MAX(op) \
   if (IS_SUSP_VAR(op)){ \
      dv_ptr = (LONG_PTR)UNTAGGED(op); \
      op = DV_last(dv_ptr); \
   } else if (ISINT(op)) { \
      op = INTVAL(op); \
   } else { \
      dv_ptr = (LONG_PTR)UNTAGGED(op); \
      op = FOLLOW(dv_ptr+1); \
   }


#define DEREF_COEFFICIENTS(op1){ \
    op3 = FOLLOW(AR+2*op1+1);DEREF_NONVAR(op3);FOLLOW(AR+2*op1+1)=op3; \
    for (i=op1+1;i<=2*op1;i++){ \
      op3 = FOLLOW(AR+i);DEREF_NONVAR(op3);FOLLOW(AR+i)=op3; \
    } \
}

/*
      if (AR <= H + MARGIN) { \
*/
#define INVOKE_GC { \
         TIDY_TRAIL; \
         SAVE_REGS; SAVE_SF; \
         garbage_collector(); \
         RESTORE_H; RESTORE_AR; RESTORE_SF; \
} 

/*
   if (AR-H<maxmem/2 && H-(LONG_PTR)AR_H(B)>MARGIN){ \
         printf("GC_NONDET\n"); \
*/
#define INVOKE_GC_NONDET { \
      SAVE_REGS; SAVE_SF; \
      garbage_collector(); \
      RESTORE_H; RESTORE_AR; RESTORE_SF; \
      OVERFLOW_C; \
} 

#define INITIALIZE_STACK_VARS(N){ \
   sreg = AR-N; \
   while (sreg!=LOCAL_TOP){ \
      FOLLOW(sreg) = (LONG)sreg; \
      sreg--; \
   }\
}


