#include  <stdio.h>
#include "inst.h"
#include "cpreds.h"
extern LONG_PTR tareg;

#define MAXINST 269

typedef struct { 
  int opcode, refer_x, refer_y;
} MEMORY_REFERENCES;

MEMORY_REFERENCES mr[MAXINST];

int total_refer_x, total_refer_y, total_insts, prev_inst =0;

int total_refer_x_inst[MAXINST],total_refer_y_inst[MAXINST];

int execution_profile[MAXINST],seq_profile[MAXINST][MAXINST],switch_type[MAXINST][4];  


LONG_PTR i_local_top,i_heap_top,i_trail_top,i_choice_top,i_table_top;
LONG_PTR c_local_top,c_heap_top,c_trail_top,c_choice_top,c_table_top;
LONG_PTR m_local_top,m_heap_top,m_trail_top,m_choice_top,m_table_top;

struct refer_xy_tab {
  char *type;
  int refer_x, refer_y;
};

struct refer_xy_tab xy_table[]={
  {"A 0",    0,0},
  {"AAA 1",  0,0},
  {"C 2",    0,0},
  {"CA 3",   0,0},
  {"E 4",    0,0},
  {"I 5",    0,0},
  {"IA 6",   0,0},
  {"III 7",  0,0},
  {"M 8",    0,1},
  {"MC 9",   0,1},
  {"N 10",   0,0},
  {"NA 11",  0,0},
  {"NAA 12", 0,0},
  {"NAZ 13", 0,0},
  {"NAZZ 14",0,0},
  {"NAZZZ 15", 0,0},
  {"NAZZZZ 16", 0,0},
  {"NS 17", 0,0},
  {"NZZ 18", 0,0},
  {"R 19", 1,0},
  {"RC 20", 1,0},
  {"S 21", 0,0},
  {"SA 22",0,0},
  {"XA 23",1,0},
  {"XAA 24",1,0},
  {"XAAA 25",1,0},
  {"XCAA 26",1,0},
  {"XI 27",1,0},
  {"XIAA 28",1,0},
  {"XNA 29",1,0},
  {"XNAA 30",1,0},
  {"XS 31",1,0},
  {"XSAA 32",1,0},
  {"XX 33",2,0},
  {"XXX 34",3,0},
  {"XXY 35",2,1},
  {"XY 36",1,1},
  {"XYA 37",1,1},
  {"XYX 38",2,1},
  {"XYY 39",1,2},
  {"YA 40",0,1},
  {"YAA 41",0,1},
  {"YAAA 42",0,1},
  {"YCA 43",0,1},
  {"YCAA 44",0,1},
  {"YI 45",0,1},
  {"YIA 46",0,1},
  {"YIAA 47",0,1},
  {"YNA 48",0,1},
  {"YNAA 49",0,1},
  {"YS 50",0,1},
  {"YSA 51",0,1},
  {"YSAA 52",0,1},
  {"YX 53",1,1},
  {"YXX 54",2,1},
  {"YXY 55",1,2},
  {"YY 56",0,2},
  {"YYA 57",0,2},
  {"YYX 58",1,2},
  {"YYY 59",0,3},
  {"YYYY 60",0,4},
  {"YYYYYY 61",0,6},
  {"Z 62",0,0},
  {"ZZ 63",0,0},
  {"ZZA 64",0,0},
  {"ZZZ 65",0,0},
  {"AA 67",0,0},
  {"NAAAS 68",0,0},
  {"YAAS 69",0,0},
  {"AAS 70",0,0},
  {"NNA 71",0,0},
  {"Z4 72",0,0},
  {"Z5 73",0,0},
  {"AASA 74",0,0},
  {"NNSA  75",0,0},
  {"Z6 76",0,0},
  {"NNAASA 77",0,0},
};

update_space_counters(l,h,t)
LONG_PTR l,h,t;
{
  c_local_top = l;
  c_heap_top = h;
  c_trail_top = t;
  if (l < m_local_top)   m_local_top = l;
  if (h > m_heap_top)  m_heap_top = h;
  if (t < m_trail_top)   m_trail_top = t;
  m_table_top = tareg;
}
  
initialize_memory_references(){

  int i;

  for (i=0; i<MAXINST; i++){
    mr[i].refer_x = xy_table[xxopcode[i].type].refer_x;
    mr[i].refer_y = xy_table[xxopcode[i].type].refer_y;
  };

  for (i=para_struct; i<=para_uy_uy_ux;i++){  /* para insts */
    if (xxopcode[i].size>=2)
      mr[i].refer_y += xxopcode[i].size-1;
    else
      mr[i].refer_y += 1;
  }
  
  mr[switch_list_yxx].refer_x +=2;

  mr[switch_list_yxy].refer_x +=1;
  mr[switch_list_yxy].refer_y +=1;

  mr[switch_list_yyx].refer_x += 1;
  mr[switch_list_yyx].refer_y += 1;

  mr[switch_list_yyy].refer_y += 2;

  mr[hash_jmpn_struct_x].refer_x += 1;
  mr[hash_jmpn_struct_y].refer_y += 1;
  mr[hash_jmpn_struct_xx].refer_x += 2;
  mr[hash_jmpn_struct_xy].refer_x += 1;
  mr[hash_jmpn_struct_xy].refer_y += 1;
  mr[hash_jmpn_struct_yx].refer_x += 1;
  mr[hash_jmpn_struct_yx].refer_y += 1;
  mr[hash_jmpn_struct_yy].refer_y += 2;

  mr[unify_cons_x].refer_y += 1;
  mr[unify_cons_y].refer_y += 1;

  mr[call].refer_y = 2;
  mr[callv].refer_y = 2;
  mr[executev].refer_y = 4;
  mr[call_d].refer_y = 2;

  mr[return_a].refer_y = 3;
  mr[return_b].refer_y = 2;

  mr[save_ht_jmp].refer_y = 2;
  mr[allocate_flat].refer_y = 1;
  mr[allocate_nondet].refer_y = 4;
  mr[fork].refer_y = 1;
  mr[commit].refer_y = 1;
  mr[cut].refer_y = 2;
  mr[cut_fail].refer_y = 3;
  mr[cut_return].refer_y = 2+3;
  mr[save_b].refer_y = 1;
  mr[getbreg].refer_y = 1;
  mr[putbreg].refer_y = 1;
  mr[getpbreg].refer_y = 1;
  mr[get_ar_cps].refer_y = 2;
  mr[put_ar_cps].refer_y = 2;
  mr[move_ar_cps].refer_y = 4;

/*  for (i=1; i<MAXINST; i++){
    printf("%20s.x=%4d .y=%4d \n",xxopcode[i].name,mr[i].refer_x,mr[i].refer_y);
  }    
*/
}

initialize_execution_profile(){
  int i;

  for (i=0; i<MAXINST; i++){
    execution_profile[i] = 0;
    total_refer_x_inst[i] = 0;
    total_refer_y_inst[i] = 0;
  }
}

initialize_seq_profile(){
  int i,j;

  for (i=0; i<MAXINST; i++)
    for (j = 0; j<MAXINST; j++)
      seq_profile[i][j] = 0;
}

initialize_switch_type(){
  int i,j;
  for (i=0;i<MAXINST;i++)
    for (j=0; i<4; i++)
      switch_type[i][j] = 0;
}
  
start_click(){
  initialize_memory_references();
  initialize_execution_profile();
  initialize_seq_profile();
  initialize_switch_type();

  total_refer_x = total_refer_y = total_insts = 0;
  m_local_top = i_local_top = c_local_top;
  m_heap_top = i_heap_top = c_heap_top;
  m_trail_top = i_trail_top = c_trail_top;
  m_table_top = i_table_top = tareg;
  i_choice_top = 0;
  return 1;
}

access_counters(){
  TERM insts,refer_x,refer_y,local_space,heap_space,trail_space,choice_space;

  insts = ARG(1,7);
  refer_x = ARG(2,7);
  refer_y = ARG(3,7);

  local_space = ARG(4,7);
  heap_space = ARG(5,7);
  trail_space = ARG(6,7);
  choice_space = ARG(7,7);
  
  unify(insts,MAKEINT(total_insts));
  unify(refer_x,MAKEINT(total_refer_x));
  unify(refer_y,MAKEINT(total_refer_y));
  unify(local_space,MAKEINT(abs((m_local_top - i_local_top))));
  unify(heap_space,MAKEINT(abs((m_heap_top - i_heap_top))));
  unify(trail_space,MAKEINT(abs((m_trail_top - i_trail_top))));
  unify(choice_space,MAKEINT(0));
  return 1;
}

print_counters(){
  int i,j;
  FILE *fp;

  fp = fopen("profile_bp","w");

/*
  for (i=0;i<MAXINST;i++){
    if (switch_type[i][0] != 0) 
      fprintf(fp,"%s   REF %d\n",xxopcode[i].name,switch_type[i][0]);
    if (switch_type[i][1] != 0) 
      fprintf(fp,"%s   STR %d\n",xxopcode[i].name,switch_type[i][1]);
    if (switch_type[i][2] != 0) 
      fprintf(fp,"%s   ATM %d\n",xxopcode[i].name,switch_type[i][2]);
    if (switch_type[i][3] != 0) 
      fprintf(fp,"%s   LST %d\n",xxopcode[i].name,switch_type[i][3]);
    }      
*/
  fprintf(fp,"total number of instructions executed: %d\n\n",total_insts);

  fprintf(fp,"X references %d\n",total_refer_x);
  fprintf(fp,"Y references %d\n",total_refer_y);

  fprintf(fp,"Execution profile:\n");
  for (i=0;i<MAXINST;i++)
    fprintf(fp,"%10d %s\n",execution_profile[i],xxopcode[i].name);
  
  fclose(fp);
  printf("local_space=%d bytes\n",(i_local_top - m_local_top)*4);
  printf("heap_space =%d bytes\n",(m_heap_top - i_heap_top)*4);
  printf("trail_space=%d bytes\n",(i_trail_top - m_trail_top)*4);
  printf("table_space=%d bytes\n",(m_table_top - tableArea)*4);
  return 1;
}

execute_inst(opcode)
int opcode;
{
  total_refer_x += mr[opcode].refer_x;
  total_refer_x_inst[opcode] += mr[opcode].refer_x;
  total_refer_y += mr[opcode].refer_y;
  total_refer_y_inst[opcode] += mr[opcode].refer_y;
  total_insts++;
  execution_profile[opcode]++;
  seq_profile[prev_inst][opcode]++;
  prev_inst = opcode;
}

distinguish_operand(op)
LONG op;
{
  if (op & 0x3 == 0x3)
    incr_refer_y(1);
  else
    incr_refer_x(1);
}

incr_refer_y(n)
int n;
{
  total_refer_y += n;
}

incr_refer_x(n)
int n;
{
  total_refer_x += n;
}

incr_switch_type(where,type)
int where,type;
{
  switch_type[where][type]++;
}

show_point(s,n)
char *s;
long n;
{
  printf("%12s %i\n",s,n);
  return;
}

Cboot_profile(){
  SYM_REC_PTR insert_cpred();

  insert_cpred("start_click",0,start_click);
  insert_cpred("access_counters",7,access_counters);
  insert_cpred("print_counters",0,print_counters);
}
