#include "basic.h"
#include "term.h"
#include "macro.h"

  extern SYM_REC_PTR insert();

int b_UNIV_fc(op1,L)
register LONG op1,L;
{
  register LONG temp,Head,top1;
  register SYM_REC_PTR     psc_ptr;
  register LONG_PTR top;
  LONG_PTR ptr;
  long int i,n,list_length();

  DEREF(L);
  if (!ISLIST(L)){
    exception = illegal_arguments;
    return -1;
  }
  UNTAG(L);
  Head = *(LONG_PTR)L;
  DEREF(Head);

  if (!ISATOM(Head)){
    exception = illegal_arguments;
    return -1;
  }
  L = *((LONG_PTR)L+1);
  DEREF(L);
  if (ISNIL(L)){          /* ATM */
    ASSIGN_f(op1,Head);
    return 1;
  }
  if (Head == period_sym){
    n = list_length(L);
    if (n<0) return n;
    if (n == 2){    /* LST */
      top1 = ADDTAG(hreg,LST);
      goto fill_components;
    }
  }
  top1 = ADDTAG(hreg,STR);  /* STR */
  psc_ptr = GET_ATM_SYM_REC(Head);
  ptr = hreg;
  hreg++;
 fill_components:
  i = 0;  /* STR or LST */
  while (ISLIST(L)){
    i++;
    UNTAG(L);
    temp = *(LONG_PTR)L;
    L = *((LONG_PTR)L+1);
    DEREF(L);
    NEW_HEAP_NODE(temp);
  }
  if (!ISNIL(L)) {
    exception = illegal_arguments;
    return -1;
  }
  if (Head == period_sym && i == 2)
    ;
  else 
    FOLLOW(ptr) = (LONG)insert(GET_NAME(psc_ptr),GET_LENGTH(psc_ptr),i);
  ASSIGN_f(op1,top1);
  return 1;
}


int b_UNIV_cf(op1,L)
register LONG op1,L;
{
  register LONG temp,tempL,Head;
  register SYM_REC_PTR     psc_ptr;
  register LONG_PTR top;
  LONG_PTR ptr;
  long int i,n,list_length();

  DEREF(op1);
  switch (TAG(op1)) {
  case REF:
    exception = illegal_arguments;
    return -1;
  case ATM:
    n = 0;
    Head = op1;
    break;
  case LST:
    n = 2;
    Head = period_sym;
    break;
  case STR:
    psc_ptr = GET_STR_SYM_REC(op1);
    n = GET_ARITY(psc_ptr);
    Head = ADDTAG(insert(GET_NAME(psc_ptr),GET_LENGTH(psc_ptr),0),ATM);
    break;
  }
  tempL = ADDTAG(hreg,LST);
  NEW_HEAP_NODE(Head);
  for (i = 1; i<=n; i++){
    temp = ADDTAG(((LONG_PTR)hreg+1),LST);
    NEW_HEAP_NODE(temp);
    NEW_HEAP_NODE(get_ARG(i,op1));
  }
  NEW_HEAP_NODE(nil_sym);
  ASSIGN_f(L,tempL);
  return 1;
}
 
long int list_length(L)
register LONG L;
{
  long int i;
  i = 0;
  DEREF(L);
  while (ISLIST(L)){
    i++;
    L = *((LONG_PTR)UNTAGGED(L)+1);
    DEREF(L);
  }
  if (!ISNIL(L)) return -1;
  return i;
}
  
/*
univ(X, L) :- 
    nonvar(X) :
    functor(X, H, N), 
    L=[H|T],
    arglist(X,T,0, N).

arglist(X,L,N,N) :- 
    true : 
    L=[].
arglist(X,L,N0,N) :- 
    true :
    N1 is N0+1,
    arg(N1,X,A), 
    L=[A|L1],
    arglist(X,L1,N1,N).

univ(X, L):-
    nonvar(L),
    [H]<=L :
    X=H.
univ(X, L):-
    nonvar(L),
    [H|T]<=L,
    atom(H) :
    length2(T,N),
    N>0,
    functor(X,H,N),
    arglist(X,T,0,N).
univ(X,L):-
    true :
handle_exception(illegal_arguments,univ(X,L)).
*/

